
/**
 *  @file mapattrmetadata.C
 *
 *  @brief Interface to get the unordered/ordered map of all target attributes
 *  with respective attribute size and read/write properties. This file is
 *  autogenerated and should not be altered.
 */

// TARG
#include <mapattrmetadata.H>

//******************************************************************************
// Macros
//******************************************************************************

#undef TARG_NAMESPACE
#undef TARG_CLASS
#undef TARG_FUNC

//******************************************************************************
// Implementation
//******************************************************************************

namespace TARGETING
{

#define TARG_NAMESPACE "TARGETING::"
#define TARG_CLASS "MapAttrMetadata::"

// Persistency defines
static const char * P0_PERSISTENCY = "p0";
static const char * P1_PERSISTENCY = "p1";
static const char * P3_PERSISTENCY = "p3";

//******************************************************************************
// TARGETING::mapAttrMetadata
//******************************************************************************

TARGETING::MapAttrMetadata& mapAttrMetadata()
{
    #define TARG_FN "mapAttrMetadata()"

    return TARG_GET_SINGLETON(TARGETING::theMapAttrMetadata);

    #undef TARG_FN
}

//******************************************************************************
// TARGETING::MapAttrMetadata::~MapAttrMetadata
//******************************************************************************

MapAttrMetadata::~MapAttrMetadata()
{
    #define TARG_FN "~MapAttrMetadata()"
    #undef TARG_FN
}

//******************************************************************************
// TARGETING::MapAttrMetadata::getMapMetadataForAllAttributes
//******************************************************************************

const AttrMetadataMapper&
MapAttrMetadata::getMapMetadataForAllAttributes() const
{
    #define TARG_FN "getMapMetadataForAllAttributes()"
    TARG_ENTER();

    TARG_EXIT();
    return iv_mapAttrMetadata;

    #undef TARG_FN
}

//******************************************************************************
// TARGETING::MapAttrMetadata::MapAttrMetadata
//******************************************************************************

MapAttrMetadata::MapAttrMetadata()
{
    #define TARG_FN "MapAttrMetadata()"

    static const Pair_t l_pair[] = {
        std::make_pair( ATTR_FREQ_PCIE_MHZ, AttrMetadataStr(sizeof(ATTR_FREQ_PCIE_MHZ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_DATA_CACHE_SIZE, AttrMetadataStr(sizeof(ATTR_DATA_CACHE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC13, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC13_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PREVIOUS_WAKEUP_FAIL, AttrMetadataStr(sizeof(ATTR_PREVIOUS_WAKEUP_FAIL_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_END_ADDR, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_END_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_MALF_ALERT_ENABLE, AttrMetadataStr(sizeof(ATTR_PM_MALF_ALERT_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_EFD_PMIC0_SWC_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_EFD_PMIC0_SWC_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRRD_L, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRRD_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_EFF_DIMM_FUNCTIONAL_VECTOR, AttrMetadataStr(sizeof(ATTR_CEN_MSS_EFF_DIMM_FUNCTIONAL_VECTOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_ROT_CDR_SSC, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_ROT_CDR_SSC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_VDDR_OFFSET_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_VDDR_OFFSET_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_TDP_RDP_CURRENT_FACTOR, AttrMetadataStr(sizeof(ATTR_TDP_RDP_CURRENT_FACTOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DQS_SWIZZLE_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DQS_SWIZZLE_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_INT_VDD_BIAS_TURBO, AttrMetadataStr(sizeof(ATTR_VOLTAGE_INT_VDD_BIAS_TURBO_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_COMPATIBILITY_REQ, AttrMetadataStr(sizeof(ATTR_PROC_COMPATIBILITY_REQ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_CDR_GAIN, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_CDR_GAIN_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_MODE_VGTARGET, AttrMetadataStr(sizeof(ATTR_HTMSC_MODE_VGTARGET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_SLEW_RATE_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_SLEW_RATE_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SS_FILTER_BYPASS, AttrMetadataStr(sizeof(ATTR_SS_FILTER_BYPASS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_PORT_MAXPOWER, AttrMetadataStr(sizeof(ATTR_EXP_PORT_MAXPOWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC0E, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC0E_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_RCV_IMP_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_RCV_IMP_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_POWER, AttrMetadataStr(sizeof(ATTR_MAX_POWER_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VPP_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VPP_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DRV_IMP_CLK, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DRV_IMP_CLK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PCIE_32BIT_MMIO_SIZE, AttrMetadataStr(sizeof(ATTR_PCIE_32BIT_MMIO_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_TSIZEFILT_PAT, AttrMetadataStr(sizeof(ATTR_HTMSC_TSIZEFILT_PAT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_ENTERPRISE_MODE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_ENTERPRISE_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_RBT, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_RBT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DIMM_RCD_IBT_ODT, AttrMetadataStr(sizeof(ATTR_MEM_SI_DIMM_RCD_IBT_ODT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_R_LOADLINE_VDN_UOHM, AttrMetadataStr(sizeof(ATTR_PROC_R_LOADLINE_VDN_UOHM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NVDIMM_FORCE_FW_UPDATE, AttrMetadataStr(sizeof(ATTR_NVDIMM_FORCE_FW_UPDATE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_REORDER_QUEUE_SETTING, AttrMetadataStr(sizeof(ATTR_MSS_REORDER_QUEUE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_A_ATTACHED_CHIP_ID, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_A_ATTACHED_CHIP_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F0BC1x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F0BC1x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_INTERNAL_VREF_MONITOR, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_INTERNAL_VREF_MONITOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_CDIMM_SPARE_I2C_TEMP_SENSOR_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_MRW_CDIMM_SPARE_I2C_TEMP_SENSOR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_EQ_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_EQ_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_LOGICAL_RANKS_PER_DIMM, AttrMetadataStr(sizeof(ATTR_MEM_EFF_LOGICAL_RANKS_PER_DIMM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_VDD_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MEM_VDD_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_DISABLE_THERM_INIT_READ, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_DISABLE_THERM_INIT_READ_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKP, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TCKMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TCKMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VCS_ID, AttrMetadataStr(sizeof(ATTR_VCS_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PB_BNDY_DMIPLL_FOR_DCCAL_DATA, AttrMetadataStr(sizeof(ATTR_PROC_PB_BNDY_DMIPLL_FOR_DCCAL_DATA_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_VDD_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_VDD_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC7X, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC7X_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DRV_IMP_CNTL, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DRV_IMP_CNTL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SENSEADJ_STEP, AttrMetadataStr(sizeof(ATTR_SENSEADJ_STEP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EQ_GARD, AttrMetadataStr(sizeof(ATTR_EQ_GARD_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_RTT_PARK, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_RTT_PARK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_RESCLK_FREQ_REGION_INDEX, AttrMetadataStr(sizeof(ATTR_SYSTEM_RESCLK_FREQ_REGION_INDEX_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_AVDD_SLOPE_ACTIVE, AttrMetadataStr(sizeof(ATTR_MSS_CENT_AVDD_SLOPE_ACTIVE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_TOTAL_PWR_SLOPE, AttrMetadataStr(sizeof(ATTR_MSS_TOTAL_PWR_SLOPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FABRIC_ADDR_EXTENSION_GROUP_ID, AttrMetadataStr(sizeof(ATTR_FABRIC_ADDR_EXTENSION_GROUP_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_MRS, AttrMetadataStr(sizeof(ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_MRS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_HTMSC_MODE_CONTENT_SEL, AttrMetadataStr(sizeof(ATTR_NHTM_HTMSC_MODE_CONTENT_SEL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT64_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT64_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_KEY_CLEAR_REQUEST, AttrMetadataStr(sizeof(ATTR_KEY_CLEAR_REQUEST_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VMEM_REGULATOR_MAX_DIMM_COUNT, AttrMetadataStr(sizeof(ATTR_MSS_VMEM_REGULATOR_MAX_DIMM_COUNT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_ENABLE_US_TMPL_5, AttrMetadataStr(sizeof(ATTR_EXPLR_ENABLE_US_TMPL_5_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC01, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC01_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_HBRT_NUM_SECTIONS, AttrMetadataStr(sizeof(ATTR_HDAT_HBRT_NUM_SECTIONS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_VCS_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_CENT_VCS_INTERCEPT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PSI_BRIDGE_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_PSI_BRIDGE_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_BLUEWATERFALL_BROKEN, AttrMetadataStr(sizeof(ATTR_CEN_MSS_BLUEWATERFALL_BROKEN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_PLL_BUCKET, AttrMetadataStr(sizeof(ATTR_NEST_PLL_BUCKET_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_RD_PREAMBLE_TRAIN, AttrMetadataStr(sizeof(ATTR_EFF_RD_PREAMBLE_TRAIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_RCD_MIRROR_MODE, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_RCD_MIRROR_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_BANK, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_BANK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PMCR_MOST_RECENT_MODE, AttrMetadataStr(sizeof(ATTR_PMCR_MOST_RECENT_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_NWELL_MISPLACEMENT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_NWELL_MISPLACEMENT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_PLL_FREQ_LIST, AttrMetadataStr(sizeof(ATTR_NEST_PLL_FREQ_LIST_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DDR4_VDDR_INTERCEPT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DDR4_VDDR_INTERCEPT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_PCIE_IOP_SWAP_NON_BIFURCATED, AttrMetadataStr(sizeof(ATTR_PEC_PCIE_IOP_SWAP_NON_BIFURCATED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PBA_LFIR, AttrMetadataStr(sizeof(ATTR_PBA_LFIR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DQ_CTLE_CAP, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DQ_CTLE_CAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_NUM_RANKS, AttrMetadataStr(sizeof(ATTR_CEN_SPD_NUM_RANKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_TMPL_1_PACING, AttrMetadataStr(sizeof(ATTR_PROC_TMPL_1_PACING_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_ALLOW_UNSUPPORTED_RCW, AttrMetadataStr(sizeof(ATTR_MSS_MRW_ALLOW_UNSUPPORTED_RCW_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_VCS_OFFSET_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_VCS_OFFSET_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_HYBRID, AttrMetadataStr(sizeof(ATTR_MEM_EFF_HYBRID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_1_VERSION_DATA, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_1_VERSION_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_CORECACHE_SKEWADJ_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_CORECACHE_SKEWADJ_DISABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_NONENTERPRISE_MODE_OVERRIDE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_NONENTERPRISE_MODE_OVERRIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_VMEM_REGULATOR_MEMORY_POWER_LIMIT_PER_DIMM_DDR4, AttrMetadataStr(sizeof(ATTR_MRW_VMEM_REGULATOR_MEMORY_POWER_LIMIT_PER_DIMM_DDR4_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ACTN, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ACTN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OMI_EDPL_DISABLE, AttrMetadataStr(sizeof(ATTR_MSS_OMI_EDPL_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OT_MIN_N_PER_MBA, AttrMetadataStr(sizeof(ATTR_OT_MIN_N_PER_MBA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_O_EREPAIR_THRESHOLD_FIELD, AttrMetadataStr(sizeof(ATTR_O_EREPAIR_THRESHOLD_FIELD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_DO_MSS_WR_VREF, AttrMetadataStr(sizeof(ATTR_DO_MSS_WR_VREF_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_WR_VREF_SCHMOO, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_WR_VREF_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CPU_ATTR, AttrMetadataStr(sizeof(ATTR_CPU_ATTR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC08, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC08_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OBUS_BRICK_LANE_MASK, AttrMetadataStr(sizeof(ATTR_OBUS_BRICK_LANE_MASK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_FORCE, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_FORCE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_HTMSC_MODE_SYNC_STAMP_FORCE, AttrMetadataStr(sizeof(ATTR_NHTM_HTMSC_MODE_SYNC_STAMP_FORCE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DIMM_RCD_IBT_CA, AttrMetadataStr(sizeof(ATTR_MEM_SI_DIMM_RCD_IBT_CA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_READ_DBI, AttrMetadataStr(sizeof(ATTR_EFF_READ_DBI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_WR_LVL_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_WR_LVL_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_I2C_SUB_POS, AttrMetadataStr(sizeof(ATTR_I2C_SUB_POS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_BASE, AttrMetadataStr(sizeof(ATTR_MEM_BASE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RAW_MTM, AttrMetadataStr(sizeof(ATTR_RAW_MTM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TCCDLMIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TCCDLMIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CHECK_FOR_READY_TIMEOUT, AttrMetadataStr(sizeof(ATTR_MSS_CHECK_FOR_READY_TIMEOUT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_RCV_IMP_ALERT_N, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_RCV_IMP_ALERT_N_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PSTATES, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PSTATES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TCE_START_TOKEN_FOR_PAYLOAD, AttrMetadataStr(sizeof(ATTR_TCE_START_TOKEN_FOR_PAYLOAD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_TSIZEFILT_MASK, AttrMetadataStr(sizeof(ATTR_HTMSC_TSIZEFILT_MASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_VRM_VDD_ERROR_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_VRM_VDD_ERROR_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_VDD_ID, AttrMetadataStr(sizeof(ATTR_NEST_VDD_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_X_BUS_WIDTH, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_X_BUS_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_SLEW_RATE_SPCKE_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_SLEW_RATE_SPCKE_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_PCLCK_CNTL_PLLA, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_PCLCK_CNTL_PLLA_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_GPU_SENSORS, AttrMetadataStr(sizeof(ATTR_GPU_SENSORS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_NUM_PEC, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_NUM_PEC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_IMAGE_MINIMUM_VALID_ECS, AttrMetadataStr(sizeof(ATTR_SBE_IMAGE_MINIMUM_VALID_ECS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_DMI_MIN_EYE_HEIGHT, AttrMetadataStr(sizeof(ATTR_MNFG_DMI_MIN_EYE_HEIGHT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_GBS, AttrMetadataStr(sizeof(ATTR_MSS_CHANNEL_PAIR_MAXBANDWIDTH_GBS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_SAFEMODE_DRAM_DATABUS_UTIL, AttrMetadataStr(sizeof(ATTR_MSS_MRW_SAFEMODE_DRAM_DATABUS_UTIL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_DMI_PER_PROC, AttrMetadataStr(sizeof(ATTR_MAX_DMI_PER_PROC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDD_AVSBUS_BUSNUM, AttrMetadataStr(sizeof(ATTR_VDD_AVSBUS_BUSNUM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_MEM_WATT_TARGET, AttrMetadataStr(sizeof(ATTR_CEN_MSS_MEM_WATT_TARGET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC08, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC08_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_CLEANER_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_CLEANER_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F1BCDx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F1BCDx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SPIPSS_FRAME_SIZE, AttrMetadataStr(sizeof(ATTR_PM_SPIPSS_FRAME_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_GPU_READ_TIMEOUT_SEC, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_GPU_READ_TIMEOUT_SEC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_LIMIT_MV, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_LIMIT_MV_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_VDDR_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_VDDR_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_NIBBLE_MAP, AttrMetadataStr(sizeof(ATTR_EFF_NIBBLE_MAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_STOPGPE_BOOT_COPIER_IVPR_OFFSET, AttrMetadataStr(sizeof(ATTR_STOPGPE_BOOT_COPIER_IVPR_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PERF_24x7_INVOCATION_TIME_MS, AttrMetadataStr(sizeof(ATTR_PERF_24x7_INVOCATION_TIME_MS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_O_MNFG_ERROR_THRESHOLD, AttrMetadataStr(sizeof(ATTR_IO_O_MNFG_ERROR_THRESHOLD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_QUAD_PPM_ERRMASK, AttrMetadataStr(sizeof(ATTR_QUAD_PPM_ERRMASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F6BC2x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F6BC2x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_PASID_BASE, AttrMetadataStr(sizeof(ATTR_EXPLR_PASID_BASE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DDP_COMPATIBILITY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DDP_COMPATIBILITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_COLUMNS, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_COLUMNS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_CK, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_CK_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXTERNAL_VRM_STEPSIZE, AttrMetadataStr(sizeof(ATTR_EXTERNAL_VRM_STEPSIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_VREF_DQ_TRAIN_RANGE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_VREF_DQ_TRAIN_RANGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_COMPLIANT_DIMMS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_COMPLIANT_DIMMS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_DDR3_VDDR_MAX_LIMIT, AttrMetadataStr(sizeof(ATTR_MRW_DDR3_VDDR_MAX_LIMIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DDR3_VDDR_INTERCEPT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DDR3_VDDR_INTERCEPT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_TX_FFE_PRECURSOR, AttrMetadataStr(sizeof(ATTR_IO_OMI_TX_FFE_PRECURSOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_MASTER_PORT, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_MASTER_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_TURBO_MODE_SUPPORTED, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_TURBO_MODE_SUPPORTED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_WR_PREAMBLE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_WR_PREAMBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_DENSITY, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_DENSITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_IS_SLOT, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_IS_SLOT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_MPR_LOC, AttrMetadataStr(sizeof(ATTR_CEN_EFF_MPR_LOC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_DOWN, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_DOWN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_USER_BANK, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_USER_BANK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FIELD_TH_P8EX_L3_COL_REPAIRS, AttrMetadataStr(sizeof(ATTR_FIELD_TH_P8EX_L3_COL_REPAIRS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F30BC4x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F30BC4x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PGPE_PHANTOM_HALT_ENABLE, AttrMetadataStr(sizeof(ATTR_PGPE_PHANTOM_HALT_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWD_VOLTAGE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWD_VOLTAGE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_SOFT_PPR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_SOFT_PPR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TEST_MIN_STRING, AttrMetadataStr(sizeof(ATTR_TEST_MIN_STRING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F1RC00, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F1RC00_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_DMI_PROC_DCCAL_FLAGS, AttrMetadataStr(sizeof(ATTR_IO_DMI_PROC_DCCAL_FLAGS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FUSED_CORE_OPTION, AttrMetadataStr(sizeof(ATTR_FUSED_CORE_OPTION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC00, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC00_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_PC_BAR_BASE_ADDR_OFFSET_MASK, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_PC_BAR_BASE_ADDR_OFFSET_MASK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_NUM_RANKS_PER_DIMM, AttrMetadataStr(sizeof(ATTR_CEN_EFF_NUM_RANKS_PER_DIMM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TCCD_L, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TCCD_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_FINE_REFRESH_MODE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_FINE_REFRESH_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_COMMIT_ID, AttrMetadataStr(sizeof(ATTR_SBE_COMMIT_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NVDIMM_ENCRYPTION_ENABLE, AttrMetadataStr(sizeof(ATTR_NVDIMM_ENCRYPTION_ENABLE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRU_ID, AttrMetadataStr(sizeof(ATTR_MRU_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_CUSTOM, AttrMetadataStr(sizeof(ATTR_CEN_SPD_CUSTOM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ALLOW_CALLHOME_ESELS_TO_BMC, AttrMetadataStr(sizeof(ATTR_ALLOW_CALLHOME_ESELS_TO_BMC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A01, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A01_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_24x7_PERF_ACCUM_ENABLE, AttrMetadataStr(sizeof(ATTR_NEST_24x7_PERF_ACCUM_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_LANE_MASK, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_LANE_MASK_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EEPROM_SBE_BACKUP_INFO, AttrMetadataStr(sizeof(ATTR_EEPROM_SBE_BACKUP_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_VREF_MC_RD, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_VREF_MC_RD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_L3_CACHE_LINE_SIZE, AttrMetadataStr(sizeof(ATTR_L3_CACHE_LINE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPC_NODE_BUFFER_GLOBAL_ADDRESS, AttrMetadataStr(sizeof(ATTR_IPC_NODE_BUFFER_GLOBAL_ADDRESS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_RD_EYE_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_RD_EYE_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A10, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A10_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_MPR_PAGE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_MPR_PAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CME_LOCAL_FIRMASK, AttrMetadataStr(sizeof(ATTR_CME_LOCAL_FIRMASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VPP_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VPP_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRFC2MIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRFC2MIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMGT_INTERNAL_FLAGS, AttrMetadataStr(sizeof(ATTR_HTMGT_INTERNAL_FLAGS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MEM_TO_USE, AttrMetadataStr(sizeof(ATTR_PROC_MEM_TO_USE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_GEN, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_GEN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OMI_DL_NUM, AttrMetadataStr(sizeof(ATTR_OMI_DL_NUM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT64_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT64_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_SLEW_RATE_DATA, AttrMetadataStr(sizeof(ATTR_CEN_MSS_SLEW_RATE_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HB_INITIATED_PM_RESET, AttrMetadataStr(sizeof(ATTR_HB_INITIATED_PM_RESET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_REGISTER_REV, AttrMetadataStr(sizeof(ATTR_EFF_REGISTER_REV_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EEPROM_SBE_PRIMARY_INFO, AttrMetadataStr(sizeof(ATTR_EEPROM_SBE_PRIMARY_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCHMOO_MULTIPLE_SETUP_CALL, AttrMetadataStr(sizeof(ATTR_SCHMOO_MULTIPLE_SETUP_CALL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F0BCDx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F0BCDx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_VMIN_MV, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_VMIN_MV_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRFC_DLR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRFC_DLR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU1_MMIO_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_NPU1_MMIO_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_L3_CACHE_SIZE, AttrMetadataStr(sizeof(ATTR_L3_CACHE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VENDOR_ID, AttrMetadataStr(sizeof(ATTR_VENDOR_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_ORIG_FIR_SETTINGS_ACTION0, AttrMetadataStr(sizeof(ATTR_ORIG_FIR_SETTINGS_ACTION0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_NUM_PACKAGES_PER_RANK, AttrMetadataStr(sizeof(ATTR_CEN_EFF_NUM_PACKAGES_PER_RANK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_DDR3_VDDR_MAX_LIMIT_POST_DRAM_INIT, AttrMetadataStr(sizeof(ATTR_MRW_DDR3_VDDR_MAX_LIMIT_POST_DRAM_INIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_MW, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_MW_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_ENABLE_DL_TMPL_1, AttrMetadataStr(sizeof(ATTR_PROC_ENABLE_DL_TMPL_1_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_VMEM_REGULATOR_POWER_LIMIT_PER_DIMM_ADJ_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_VMEM_REGULATOR_POWER_LIMIT_PER_DIMM_ADJ_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NPU_MMIO_BAR_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_NPU_MMIO_BAR_BASE_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PRIMARY_CAPABILITIES, AttrMetadataStr(sizeof(ATTR_PRIMARY_CAPABILITIES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_TM1_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_TM1_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOF_ENABLED, AttrMetadataStr(sizeof(ATTR_WOF_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPTICS_CONFIG_MODE, AttrMetadataStr(sizeof(ATTR_OPTICS_CONFIG_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EEPROM_PAGE_ARRAY, AttrMetadataStr(sizeof(ATTR_EEPROM_PAGE_ARRAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PHYS_PRES_ASSERTED, AttrMetadataStr(sizeof(ATTR_PHYS_PRES_ASSERTED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_DCCAL_FLAGS, AttrMetadataStr(sizeof(ATTR_IO_OMI_DCCAL_FLAGS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_M_CNTL, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_M_CNTL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRRD, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRRD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F5BC5x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F5BC5x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_VIO_ID, AttrMetadataStr(sizeof(ATTR_NEST_VIO_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_PROC_DVFS_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_PROC_DVFS_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NVDIMM_ENCRYPTION_KEYS_FW, AttrMetadataStr(sizeof(ATTR_NVDIMM_ENCRYPTION_KEYS_FW_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_RUNTIME_MODE, AttrMetadataStr(sizeof(ATTR_SBE_RUNTIME_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPMI_SENSORS, AttrMetadataStr(sizeof(ATTR_IPMI_SENSORS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IBSCOM_MCS_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_IBSCOM_MCS_BASE_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_START_MEM_ADDRESS_FOR_PAYLOAD_TCE_TOKEN, AttrMetadataStr(sizeof(ATTR_START_MEM_ADDRESS_FOR_PAYLOAD_TCE_TOKEN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_CL, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_CL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_X_DEBUG, AttrMetadataStr(sizeof(ATTR_IO_X_DEBUG_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_PPR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_PPR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PCIE_32BIT_DMA_SIZE, AttrMetadataStr(sizeof(ATTR_PCIE_32BIT_DMA_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_UNSECURE_HOMER_ADDRESS, AttrMetadataStr(sizeof(ATTR_UNSECURE_HOMER_ADDRESS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TRCDMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TRCDMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SPIPSS_CLOCK_POLARITY, AttrMetadataStr(sizeof(ATTR_PM_SPIPSS_CLOCK_POLARITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BLOCK_SPEC_DECONFIG, AttrMetadataStr(sizeof(ATTR_BLOCK_SPEC_DECONFIG_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_RCD_PARITY_ERRORS, AttrMetadataStr(sizeof(ATTR_MNFG_TH_RCD_PARITY_ERRORS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWD_VOLTAGE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWD_VOLTAGE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FIELD_TH_P8EX_L3_LINE_DELETES, AttrMetadataStr(sizeof(ATTR_FIELD_TH_P8EX_L3_LINE_DELETES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PFET_OFF_CONTROLS, AttrMetadataStr(sizeof(ATTR_PFET_OFF_CONTROLS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRFCMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRFCMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWC_VOLTAGE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWC_VOLTAGE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC03, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC03_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_WR_EYE_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_WR_EYE_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_ADDR_MODE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_ADDR_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_TEMP_READOUT, AttrMetadataStr(sizeof(ATTR_CEN_EFF_TEMP_READOUT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_STRICT_MBA_PLUG_RULE_CHECKING, AttrMetadataStr(sizeof(ATTR_CEN_MRW_STRICT_MBA_PLUG_RULE_CHECKING_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MBA_PORT, AttrMetadataStr(sizeof(ATTR_MBA_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_QUATERNARY_RANK_GROUP0, AttrMetadataStr(sizeof(ATTR_CEN_EFF_QUATERNARY_RANK_GROUP0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_COLS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_COLS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_A_LINK_DELAY, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_A_LINK_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_STRUCT_MMIO_WORD_SWAP, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_STRUCT_MMIO_WORD_SWAP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_CTRL_DBG0_STOP, AttrMetadataStr(sizeof(ATTR_HTMSC_CTRL_DBG0_STOP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A09, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A09_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A11, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A11_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PCIE_CAPABILITES, AttrMetadataStr(sizeof(ATTR_PCIE_CAPABILITES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_TRAIN_FOR_RECOVERY, AttrMetadataStr(sizeof(ATTR_IO_OBUS_TRAIN_FOR_RECOVERY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRRDLMIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRRDLMIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_EXS_PER_PROC_CHIP, AttrMetadataStr(sizeof(ATTR_MAX_EXS_PER_PROC_CHIP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_GEARDOWN_MODE, AttrMetadataStr(sizeof(ATTR_EFF_GEARDOWN_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_DRAM_WRITE_CRC, AttrMetadataStr(sizeof(ATTR_MSS_MRW_DRAM_WRITE_CRC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OT_MEM_POWER, AttrMetadataStr(sizeof(ATTR_OT_MEM_POWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU_PHY0_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_NPU_PHY0_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_C1_HASPOWER, AttrMetadataStr(sizeof(ATTR_C1_HASPOWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_MPR_RD_FORMAT, AttrMetadataStr(sizeof(ATTR_EFF_MPR_RD_FORMAT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_EFD_PMIC1_SWD_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_EFD_PMIC1_SWD_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWA_VOLTAGE_RANGE_SELECT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWA_VOLTAGE_RANGE_SELECT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWC_SEQUENCE_ORDER, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWC_SEQUENCE_ORDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_FILT_PAT, AttrMetadataStr(sizeof(ATTR_HTMSC_FILT_PAT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F4BC2x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F4BC2x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_LPASR, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_LPASR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_LIMIT_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_LIMIT_10THPCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_RESCLK_L3_VOLTAGE_THRESHOLD_MV, AttrMetadataStr(sizeof(ATTR_SYSTEM_RESCLK_L3_VOLTAGE_THRESHOLD_MV_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_DROOP_LARGE_OVERRIDE, AttrMetadataStr(sizeof(ATTR_VDM_DROOP_LARGE_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_ODT_WR, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_ODT_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TYPE, AttrMetadataStr(sizeof(ATTR_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_AFU_ACTAG_LEN, AttrMetadataStr(sizeof(ATTR_EXPLR_AFU_ACTAG_LEN_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TIMEBASE_FTB_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TIMEBASE_FTB_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_FREQ, AttrMetadataStr(sizeof(ATTR_CEN_MSS_FREQ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_ODT_INPUT_BUFF, AttrMetadataStr(sizeof(ATTR_CEN_EFF_ODT_INPUT_BUFF_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWA_VOLTAGE_RANGE_SELECT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWA_VOLTAGE_RANGE_SELECT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_AVDD_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_CENT_AVDD_INTERCEPT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F6BC5x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F6BC5x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_REVISION_CODE, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_REVISION_CODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F0RC04, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F0RC04_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_UCD_MFR_REVISION_OVERRIDE, AttrMetadataStr(sizeof(ATTR_UCD_MFR_REVISION_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU1_MMIO_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_NPU1_MMIO_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC08, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC08_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EFF_ODT_WR, AttrMetadataStr(sizeof(ATTR_MSS_EFF_ODT_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_IBM_TYPE, AttrMetadataStr(sizeof(ATTR_EFF_IBM_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT8_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT8_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU_PHY0_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_NPU_PHY0_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_DRAM_DEVICE_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_SPD_DRAM_DEVICE_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_POUNDV_BUCKET_NUM, AttrMetadataStr(sizeof(ATTR_POUNDV_BUCKET_NUM_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_PPR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_PPR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRFC1MIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRFC1MIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CKE, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CKE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OMI_PLL_VCO, AttrMetadataStr(sizeof(ATTR_OMI_PLL_VCO_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_PCIE_LANE_MASK_BIFURCATED, AttrMetadataStr(sizeof(ATTR_PEC_PCIE_LANE_MASK_BIFURCATED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NX_RNG_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_NX_RNG_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_DIMM_THERMAL_LIMIT, AttrMetadataStr(sizeof(ATTR_MSS_DIMM_THERMAL_LIMIT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DMI_EREPAIR_THRESHOLD_MNFG, AttrMetadataStr(sizeof(ATTR_DMI_EREPAIR_THRESHOLD_MNFG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_ENABLED, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SPIPSS_IN_DELAY, AttrMetadataStr(sizeof(ATTR_PM_SPIPSS_IN_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OMI_DL_LN_REV_ENABLE, AttrMetadataStr(sizeof(ATTR_OMI_DL_LN_REV_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SAVED_STATE_UINT8, AttrMetadataStr(sizeof(ATTR_SAVED_STATE_UINT8_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BPM_UPDATE_OVERRIDE, AttrMetadataStr(sizeof(ATTR_BPM_UPDATE_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWD_SEQUENCE_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWD_SEQUENCE_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ISTEP_PAUSE_CONFIG, AttrMetadataStr(sizeof(ATTR_ISTEP_PAUSE_CONFIG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_X_ADDR_DIS, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_X_ADDR_DIS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CDM_DOMAIN, AttrMetadataStr(sizeof(ATTR_CDM_DOMAIN_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_TX_MARGIN_RATIO, AttrMetadataStr(sizeof(ATTR_IO_OBUS_TX_MARGIN_RATIO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_IC_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_IC_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_START_ADDR, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_START_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_MODULE_THERMAL_SENSORS, AttrMetadataStr(sizeof(ATTR_MEM_EFF_MODULE_THERMAL_SENSORS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_EXT_VDD_BIAS_NOMINAL, AttrMetadataStr(sizeof(ATTR_VOLTAGE_EXT_VDD_BIAS_NOMINAL_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_INTERLEAVE_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_INTERLEAVE_ENABLE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_BRAZOS_RX_FIFO_OVERRIDE, AttrMetadataStr(sizeof(ATTR_BRAZOS_RX_FIFO_OVERRIDE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_DEVICE_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_DEVICE_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_WR_PREAMBLE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_WR_PREAMBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_HOST_TO_DDR_SPEED_RATIO, AttrMetadataStr(sizeof(ATTR_MEM_EFF_HOST_TO_DDR_SPEED_RATIO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DO_MSS_VREF_DAC, AttrMetadataStr(sizeof(ATTR_DO_MSS_VREF_DAC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_RESCLK_L3_VALUE, AttrMetadataStr(sizeof(ATTR_SYSTEM_RESCLK_L3_VALUE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_CRC_WR_LATENCY, AttrMetadataStr(sizeof(ATTR_EFF_CRC_WR_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_STACK_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_STACK_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OMI_INBAND_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_OMI_INBAND_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_R_DISTLOSS_VDN_UOHM, AttrMetadataStr(sizeof(ATTR_PROC_R_DISTLOSS_VDN_UOHM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_CRC_ERROR_CLEAR, AttrMetadataStr(sizeof(ATTR_EFF_CRC_ERROR_CLEAR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EFF_DPHY_RLO, AttrMetadataStr(sizeof(ATTR_MSS_EFF_DPHY_RLO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_POWER_SLOPE2, AttrMetadataStr(sizeof(ATTR_CEN_MSS_POWER_SLOPE2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_P8EX_L2_COL_REPAIRS, AttrMetadataStr(sizeof(ATTR_MNFG_TH_P8EX_L2_COL_REPAIRS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_INIT_GAIN, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_INIT_GAIN_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SPIPSS_CLOCK_PHASE, AttrMetadataStr(sizeof(ATTR_PM_SPIPSS_CLOCK_PHASE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_DIMM_READ_TIMEOUT_SEC, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_DIMM_READ_TIMEOUT_SEC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_REVISION_CODE_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_REVISION_CODE_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CME_PSTATE_PHANTOM_HALT_ENABLE, AttrMetadataStr(sizeof(ATTR_CME_PSTATE_PHANTOM_HALT_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_POUNDV_VALIDITY_HALT_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_POUNDV_VALIDITY_HALT_DISABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_PATTERN, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_PATTERN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SP_FUNCTIONS, AttrMetadataStr(sizeof(ATTR_SP_FUNCTIONS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SECURITY_ENABLE, AttrMetadataStr(sizeof(ATTR_SECURITY_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_CACHE_INJ_THROTTLE, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_CACHE_INJ_THROTTLE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_WRDDR4_VREF_SCHMOO, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_WRDDR4_VREF_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_LOCATION_CODE, AttrMetadataStr(sizeof(ATTR_LOCATION_CODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CP_FILTER_BYPASS, AttrMetadataStr(sizeof(ATTR_CP_FILTER_BYPASS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_NUM_MASTER_RANKS_PER_DIMM, AttrMetadataStr(sizeof(ATTR_CEN_EFF_NUM_MASTER_RANKS_PER_DIMM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_6x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_6x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_C1_EXEC_HASCLOCKS, AttrMetadataStr(sizeof(ATTR_C1_EXEC_HASCLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FIELD_CORE_OVERRIDE, AttrMetadataStr(sizeof(ATTR_FIELD_CORE_OVERRIDE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_DQ, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_DQ_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EEPROM_CONTENT_TYPE, AttrMetadataStr(sizeof(ATTR_EEPROM_CONTENT_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_DFE_FDDC, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_DFE_FDDC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HIDDEN_ERRLOGS_ENABLE, AttrMetadataStr(sizeof(ATTR_HIDDEN_ERRLOGS_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SAFE_MODE_NOVDM_UPLIFT_MV, AttrMetadataStr(sizeof(ATTR_SAFE_MODE_NOVDM_UPLIFT_MV_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_PASID_LEN, AttrMetadataStr(sizeof(ATTR_EXPLR_PASID_LEN_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_ROW_BITS, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_ROW_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT, AttrMetadataStr(sizeof(ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_TX_FFE_POSTCURSOR, AttrMetadataStr(sizeof(ATTR_IO_OMI_TX_FFE_POSTCURSOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_XBUS_CHAN_EQ, AttrMetadataStr(sizeof(ATTR_IO_XBUS_CHAN_EQ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_FREQ, AttrMetadataStr(sizeof(ATTR_MSS_FREQ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_DEVICE_TYPE, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_DEVICE_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC01, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC01_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DUMMY_HEAP_ZERO_DEFAULT, AttrMetadataStr(sizeof(ATTR_DUMMY_HEAP_ZERO_DEFAULT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TRRDSMIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TRRDSMIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F30BC9x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F30BC9x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MODEL, AttrMetadataStr(sizeof(ATTR_MODEL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCOM_SWITCHES, AttrMetadataStr(sizeof(ATTR_SCOM_SWITCHES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC07, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC07_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PAYLOAD_ENTRY, AttrMetadataStr(sizeof(ATTR_PAYLOAD_ENTRY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_DQS_CLK_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_DQS_CLK_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_CTRL_CHIP0_STOP, AttrMetadataStr(sizeof(ATTR_HTMSC_CTRL_CHIP0_STOP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ENABLED_OBUS_BRICKS, AttrMetadataStr(sizeof(ATTR_ENABLED_OBUS_BRICKS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MINI_EC, AttrMetadataStr(sizeof(ATTR_MINI_EC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_PRINTING_DISABLE, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_PRINTING_DISABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_MIN_POWER_CAP_WATTS, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_MIN_POWER_CAP_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F30BCAx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F30BCAx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU2_PRI_CONFIG, AttrMetadataStr(sizeof(ATTR_PROC_NPU2_PRI_CONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_VREF_DQ_TRAIN_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_VREF_DQ_TRAIN_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_VREF_DQ_TRAIN_VALUE, AttrMetadataStr(sizeof(ATTR_EFF_VREF_DQ_TRAIN_VALUE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_SPARE, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_SPARE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MMIO_PHYS_ADDR, AttrMetadataStr(sizeof(ATTR_MMIO_PHYS_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_O_MHZ, AttrMetadataStr(sizeof(ATTR_FREQ_O_MHZ_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_0_I2C_ADDR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_0_I2C_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT64_ARRAY_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT64_ARRAY_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PIB_I2C_REFCLOCK, AttrMetadataStr(sizeof(ATTR_PIB_I2C_REFCLOCK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_CL, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_CL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EEPROM_VPD_PRIMARY_INFO, AttrMetadataStr(sizeof(ATTR_EEPROM_VPD_PRIMARY_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MIRROR_BASES_ACK, AttrMetadataStr(sizeof(ATTR_PROC_MIRROR_BASES_ACK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OBUS_SLOT_INDEX, AttrMetadataStr(sizeof(ATTR_OBUS_SLOT_INDEX_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DRV_IMP_CSCID, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DRV_IMP_CSCID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_CWL, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_CWL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_VDDR_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MEM_VDDR_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SGPE_PHANTOM_HALT_ENABLE, AttrMetadataStr(sizeof(ATTR_SGPE_PHANTOM_HALT_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CS_CMD_LATENCY, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CS_CMD_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_ASYNC_SAFE_MODE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_ASYNC_SAFE_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_OVERV_STEP_INCR_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_OVERV_STEP_INCR_10THPCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC0E, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC0E_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CVPD_MAX_SECTIONS, AttrMetadataStr(sizeof(ATTR_CVPD_MAX_SECTIONS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_LRDIMM_MR12_REG, AttrMetadataStr(sizeof(ATTR_LRDIMM_MR12_REG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EEPROM_VPD_BACKUP_INFO, AttrMetadataStr(sizeof(ATTR_EEPROM_VPD_BACKUP_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_DRAM_2N_MODE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_DRAM_2N_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A04, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A04_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DCACHE_LINE_SIZE, AttrMetadataStr(sizeof(ATTR_DCACHE_LINE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MTB_DIVIDEND, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MTB_DIVIDEND_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ALTFSI_MASTER_PORT, AttrMetadataStr(sizeof(ATTR_ALTFSI_MASTER_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EI_BUS_TX_MSBSWAP, AttrMetadataStr(sizeof(ATTR_EI_BUS_TX_MSBSWAP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DRAM_RTT_WR, AttrMetadataStr(sizeof(ATTR_MEM_SI_DRAM_RTT_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDDR_ID, AttrMetadataStr(sizeof(ATTR_VDDR_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_ULTRA_TURBO_FREQ_MHZ, AttrMetadataStr(sizeof(ATTR_ULTRA_TURBO_FREQ_MHZ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TLB_RESERVE_SIZE, AttrMetadataStr(sizeof(ATTR_TLB_RESERVE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PIBMEM_REPAIR1, AttrMetadataStr(sizeof(ATTR_PIBMEM_REPAIR1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SEQUENCE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SEQUENCE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDN_AVSBUS_BUSNUM, AttrMetadataStr(sizeof(ATTR_VDN_AVSBUS_BUSNUM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_SLAVE_RANK_ON, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_SLAVE_RANK_ON_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_STOP4_DISABLE, AttrMetadataStr(sizeof(ATTR_STOP4_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_XSCOM_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_XSCOM_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_HTMSC_MODE_CAPTURE_ENABLE_FILTER_ALL, AttrMetadataStr(sizeof(ATTR_NHTM_HTMSC_MODE_CAPTURE_ENABLE_FILTER_ALL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_SPD_CL_SUPPORTED, AttrMetadataStr(sizeof(ATTR_MEM_EXP_SPD_CL_SUPPORTED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_MFG_CHK, AttrMetadataStr(sizeof(ATTR_IO_OMI_MFG_CHK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SECTOR_BUFFER_STRENGTH, AttrMetadataStr(sizeof(ATTR_SECTOR_BUFFER_STRENGTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_ELEMENTS, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_ELEMENTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F4BC5x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F4BC5x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_7x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_7x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_VDDR_ID, AttrMetadataStr(sizeof(ATTR_NEST_VDDR_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_SYSTEM_ID, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_SYSTEM_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_GPU_MEM_READ_TIMEOUT_SEC, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_GPU_MEM_READ_TIMEOUT_SEC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_RESCLK_ENABLED, AttrMetadataStr(sizeof(ATTR_RESCLK_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DYNAMIC_I2C_DEVICE_ADDRESS, AttrMetadataStr(sizeof(ATTR_DYNAMIC_I2C_DEVICE_ADDRESS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RECONFIGURE_LOOP, AttrMetadataStr(sizeof(ATTR_RECONFIGURE_LOOP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_INTP_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_INTP_BASE_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TWTR_S, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TWTR_S_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EC_GARD, AttrMetadataStr(sizeof(ATTR_EC_GARD_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DATABUS_UTIL_PER_MBA, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DATABUS_UTIL_PER_MBA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DQ_CTLE_RES, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DQ_CTLE_RES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_X_MHZ, AttrMetadataStr(sizeof(ATTR_FREQ_X_MHZ_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_CTRL_CHIP1_STOP, AttrMetadataStr(sizeof(ATTR_HTMSC_CTRL_CHIP1_STOP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_INT_VDD_BIAS_ULTRATURBO, AttrMetadataStr(sizeof(ATTR_VOLTAGE_INT_VDD_BIAS_ULTRATURBO_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MIRROR_BASE_ADDRESS, AttrMetadataStr(sizeof(ATTR_MIRROR_BASE_ADDRESS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_P8EX_L3_DIR_CES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_P8EX_L3_DIR_CES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_VRM_VDD_READ_TIMEOUT_SEC, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_VRM_VDD_READ_TIMEOUT_SEC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_HALF_DIMM_MODE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_HALF_DIMM_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC03, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC03_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWD_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWD_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_CA_PARITY, AttrMetadataStr(sizeof(ATTR_EFF_CA_PARITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_HTMSC_MODE_CAPTURE_GENERATED_WRITES, AttrMetadataStr(sizeof(ATTR_NHTM_HTMSC_MODE_CAPTURE_GENERATED_WRITES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_WRITE_CRC, AttrMetadataStr(sizeof(ATTR_CEN_EFF_WRITE_CRC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWC_SEQUENCE_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWC_SEQUENCE_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWD_SEQUENCE_ORDER, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWD_SEQUENCE_ORDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RCD_PARITY_RECONFIG_LOOPS_ALLOWED, AttrMetadataStr(sizeof(ATTR_RCD_PARITY_RECONFIG_LOOPS_ALLOWED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXTERNAL_VRM_TRANSITION_RATE_INC_UV_PER_US, AttrMetadataStr(sizeof(ATTR_EXTERNAL_VRM_TRANSITION_RATE_INC_UV_PER_US_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_Bx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_Bx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DATA_MASK, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DATA_MASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRASMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRASMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWB_VOLTAGE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWB_VOLTAGE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F0RC0F, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F0RC0F_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_WR_LVL_ENABLE, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_WR_LVL_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CORE_PPM_ERRMASK, AttrMetadataStr(sizeof(ATTR_CORE_PPM_ERRMASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VPP_INTERCEPT_POST_DRAM_INIT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VPP_INTERCEPT_POST_DRAM_INIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_WOV_OVERV_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_WOV_OVERV_DISABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_C0_PC_HASCLOCKS, AttrMetadataStr(sizeof(ATTR_C0_PC_HASCLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PAYLOAD_IN_MIRROR_MEM, AttrMetadataStr(sizeof(ATTR_PAYLOAD_IN_MIRROR_MEM_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_WRITE_DBI, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_WRITE_DBI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SUPPORTS_DYNAMIC_MEM_VOLT, AttrMetadataStr(sizeof(ATTR_SUPPORTS_DYNAMIC_MEM_VOLT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_6x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_6x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_5x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_5x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_PCIE_IOP_REVERSAL, AttrMetadataStr(sizeof(ATTR_PEC_PCIE_IOP_REVERSAL_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_STOP8_DISABLE, AttrMetadataStr(sizeof(ATTR_STOP8_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FSP_BAR_SIZE, AttrMetadataStr(sizeof(ATTR_FSP_BAR_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_BOOT_CONFIG_ADAPTATION_MODE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_ADAPTATION_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HUGE_PAGE_SIZE, AttrMetadataStr(sizeof(ATTR_HUGE_PAGE_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRRD_L, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRRD_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PRIM_BUS_WIDTH, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PRIM_BUS_WIDTH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_GPU_ERROR_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_GPU_ERROR_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FSI_MASTER_TYPE, AttrMetadataStr(sizeof(ATTR_FSI_MASTER_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_TOD_CPU_DATA, AttrMetadataStr(sizeof(ATTR_TOD_CPU_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_ENABLE_DL_TMPL_7, AttrMetadataStr(sizeof(ATTR_PROC_ENABLE_DL_TMPL_7_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_LINK_TRAIN, AttrMetadataStr(sizeof(ATTR_LINK_TRAIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWA_SEQUENCE_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWA_SEQUENCE_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPP_PROGRAM, AttrMetadataStr(sizeof(ATTR_MSS_VPP_PROGRAM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_CEN_MBA_RT_RCE_PER_RANK, AttrMetadataStr(sizeof(ATTR_MNFG_TH_CEN_MBA_RT_RCE_PER_RANK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MBVPD_VERSION, AttrMetadataStr(sizeof(ATTR_CEN_MBVPD_VERSION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_A_ATTACHED_CHIP_CNFG, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_A_ATTACHED_CHIP_CNFG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_TEMP_REFRESH_RANGE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_TEMP_REFRESH_RANGE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_9x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_9x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEMVPD_POS, AttrMetadataStr(sizeof(ATTR_MEMVPD_POS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_TLB_DATA_ASSOC_SETS, AttrMetadataStr(sizeof(ATTR_TLB_DATA_ASSOC_SETS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_GROUP_MASTER_CHIP, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_GROUP_MASTER_CHIP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F5BC2x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F5BC2x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SMF_ENABLED, AttrMetadataStr(sizeof(ATTR_SMF_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F1RC04, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F1RC04_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRP, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHIP_REGIONS_TO_ENABLE, AttrMetadataStr(sizeof(ATTR_CHIP_REGIONS_TO_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_RANDOM_SEED_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_RANDOM_SEED_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_OCMB_PWR_SLOPE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_OCMB_PWR_SLOPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_VCS_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MEM_VCS_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_VID_COMPARE_BIAS_0P5PCT, AttrMetadataStr(sizeof(ATTR_VDM_VID_COMPARE_BIAS_0P5PCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_L2_HASCLOCKS, AttrMetadataStr(sizeof(ATTR_L2_HASCLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ASYNC_NEST_FREQ_MHZ, AttrMetadataStr(sizeof(ATTR_ASYNC_NEST_FREQ_MHZ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CUSTOM_TRAINING_ADV_PATTERNS, AttrMetadataStr(sizeof(ATTR_MSS_CUSTOM_TRAINING_ADV_PATTERNS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PLCK_IPL_ATTR_OVERRIDES_EXIST, AttrMetadataStr(sizeof(ATTR_PLCK_IPL_ATTR_OVERRIDES_EXIST_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_MODE, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ALTFSI_MASTER_CHIP, AttrMetadataStr(sizeof(ATTR_ALTFSI_MASTER_CHIP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWC_SEQUENCE_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWC_SEQUENCE_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_NUM_ROWS, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_NUM_ROWS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_IPL_PHASE, AttrMetadataStr(sizeof(ATTR_SYSTEM_IPL_PHASE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_TX_FFE_POSTCURSOR, AttrMetadataStr(sizeof(ATTR_IO_OBUS_TX_FFE_POSTCURSOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWA_SEQUENCE_ORDER, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWA_SEQUENCE_ORDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXTERNAL_VRM_TRANSITION_START_NS, AttrMetadataStr(sizeof(ATTR_EXTERNAL_VRM_TRANSITION_START_NS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_TPM_REQUIRED, AttrMetadataStr(sizeof(ATTR_TPM_REQUIRED_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_RBT, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_RBT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SLCA_INDEX, AttrMetadataStr(sizeof(ATTR_SLCA_INDEX_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CA, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_MEM_PORT_POS_OF_FAIL_THROTTLE, AttrMetadataStr(sizeof(ATTR_EXP_MEM_PORT_POS_OF_FAIL_THROTTLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_X_ATTACHED_LINK_ID, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_X_ATTACHED_LINK_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_DIMM_THROTTLE_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_DIMM_THROTTLE_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRFC, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRFC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_WR_VREF_CHECK_VREF_STEP_SIZE, AttrMetadataStr(sizeof(ATTR_CEN_MRW_WR_VREF_CHECK_VREF_STEP_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_2N_MODE, AttrMetadataStr(sizeof(ATTR_MEM_2N_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CUSTOM_DIMM, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CUSTOM_DIMM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FABRIC_ADDR_EXTENSION_CHIP_ID, AttrMetadataStr(sizeof(ATTR_FABRIC_ADDR_EXTENSION_CHIP_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MTB_DIVISOR, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MTB_DIVISOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWB_SEQUENCE_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWB_SEQUENCE_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FILTER_PLL_BUCKET, AttrMetadataStr(sizeof(ATTR_FILTER_PLL_BUCKET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC05, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC05_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_POST_DRAM_INIT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_POST_DRAM_INIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWD_VOLTAGE_RANGE_SELECT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWD_VOLTAGE_RANGE_SELECT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT64_ARRAY_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT64_ARRAY_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TEST_MAX_STRING, AttrMetadataStr(sizeof(ATTR_TEST_MAX_STRING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMGT_PMCOMPLEX_RESET_COUNT_TIMER, AttrMetadataStr(sizeof(ATTR_HTMGT_PMCOMPLEX_RESET_COUNT_TIMER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_START_CBS_FIFO_RESET_SKIP, AttrMetadataStr(sizeof(ATTR_START_CBS_FIFO_RESET_SKIP_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_MCS_PREFETCH_RETRY_THRESHOLD, AttrMetadataStr(sizeof(ATTR_CEN_MRW_MCS_PREFETCH_RETRY_THRESHOLD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_BAD_DQ_DATA, AttrMetadataStr(sizeof(ATTR_CEN_SPD_BAD_DQ_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_RCV_IMP_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_RCV_IMP_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_RD_GATE_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_RD_GATE_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_HTMSC_MODE_CAPTURE_PMISC_ONLY_CMD, AttrMetadataStr(sizeof(ATTR_NHTM_HTMSC_MODE_CAPTURE_PMISC_ONLY_CMD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_TEMP_REF_MODE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_TEMP_REF_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TARGET_IS_SCOMMABLE, AttrMetadataStr(sizeof(ATTR_TARGET_IS_SCOMMABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_P8EX_L2_LINE_DELETES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_P8EX_L2_LINE_DELETES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_VID_COMPARE_OVERRIDE_MV, AttrMetadataStr(sizeof(ATTR_VDM_VID_COMPARE_OVERRIDE_MV_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_X_MFG_MIN_EYE_WIDTH, AttrMetadataStr(sizeof(ATTR_IO_X_MFG_MIN_EYE_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_ASR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_ASR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_SLEW_RATE_CSCID, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_SLEW_RATE_CSCID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_OVERRIDE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VDDR_PROGRAM, AttrMetadataStr(sizeof(ATTR_MSS_VDDR_PROGRAM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_COLUMN_BITS, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_COLUMN_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_POWER_INT2, AttrMetadataStr(sizeof(ATTR_CEN_MSS_POWER_INT2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SECONDARY_RANK_GROUP0, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SECONDARY_RANK_GROUP0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_INT_VREF_MON, AttrMetadataStr(sizeof(ATTR_CEN_EFF_INT_VREF_MON_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DATA_MASK, AttrMetadataStr(sizeof(ATTR_EFF_DATA_MASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ORIG_FIR_SETTINGS_ACTION1, AttrMetadataStr(sizeof(ATTR_ORIG_FIR_SETTINGS_ACTION1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC10, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC10_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_TOTAL_POWER_INT2, AttrMetadataStr(sizeof(ATTR_CEN_MSS_TOTAL_POWER_INT2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_USE_TCES_FOR_DMAS, AttrMetadataStr(sizeof(ATTR_USE_TCES_FOR_DMAS_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F70BC7x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F70BC7x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CALCULATED_MAX_SYS_POWER_EXCLUDING_GPUS, AttrMetadataStr(sizeof(ATTR_CALCULATED_MAX_SYS_POWER_EXCLUDING_GPUS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_TOTAL_POWER_INT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_TOTAL_POWER_INT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_DROOP_EXTREME_OVERRIDE, AttrMetadataStr(sizeof(ATTR_VDM_DROOP_EXTREME_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SOCKET_POWER_NOMINAL, AttrMetadataStr(sizeof(ATTR_SOCKET_POWER_NOMINAL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_DPHY_GPO, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_DPHY_GPO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_FIRINIT_DONE_ONCE_FLAG, AttrMetadataStr(sizeof(ATTR_PM_FIRINIT_DONE_ONCE_FLAG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_PERF_LOSS_THRESH_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_PERF_LOSS_THRESH_10THPCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_VPP_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_VPP_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_VRM_VOFFSET_VDD_UV, AttrMetadataStr(sizeof(ATTR_PROC_VRM_VOFFSET_VDD_UV_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_NVDIMM_SLOT_POSITION, AttrMetadataStr(sizeof(ATTR_MSS_MRW_NVDIMM_SLOT_POSITION_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_VREF_DQ_TRAIN_ENABLE, AttrMetadataStr(sizeof(ATTR_EFF_VREF_DQ_TRAIN_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_VDD_SLOPE_ACTIVE, AttrMetadataStr(sizeof(ATTR_MSS_CENT_VDD_SLOPE_ACTIVE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PRD_HWP_PLID, AttrMetadataStr(sizeof(ATTR_PRD_HWP_PLID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_NEST_CAPABLE_FREQUENCIES, AttrMetadataStr(sizeof(ATTR_CEN_MSS_NEST_CAPABLE_FREQUENCIES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_TSYS_DATA, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_TSYS_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IS_INTER_ENCLOSURE_BUS, AttrMetadataStr(sizeof(ATTR_IS_INTER_ENCLOSURE_BUS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC0F, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC0F_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_OCC_SANDBOX_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_PROC_OCC_SANDBOX_BASE_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYNC_BETWEEN_STEPS, AttrMetadataStr(sizeof(ATTR_SYNC_BETWEEN_STEPS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_DIMM_POWER_CURVE_PERCENT_UPLIFT, AttrMetadataStr(sizeof(ATTR_MSS_MRW_DIMM_POWER_CURVE_PERCENT_UPLIFT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDD_BOOT_VOLTAGE, AttrMetadataStr(sizeof(ATTR_VDD_BOOT_VOLTAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_CASN_A15, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_CASN_A15_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_PER_DRAM_ACCESS, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_PER_DRAM_ACCESS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_RCD_DIC, AttrMetadataStr(sizeof(ATTR_MEM_EXP_RCD_DIC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWA_VOLTAGE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWA_VOLTAGE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_SLAVE_PORT, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_SLAVE_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC00, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC00_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_MR_ENABLE, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_MR_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_TOTAL_POWER_SLOPE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_TOTAL_POWER_SLOPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_RD_PREAMBLE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_RD_PREAMBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_SLEW_RATE_CLK_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_SLEW_RATE_CLK_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_C0_HASPOWER, AttrMetadataStr(sizeof(ATTR_C0_HASPOWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_AVDD_SLOPE_INACTIVE, AttrMetadataStr(sizeof(ATTR_MSS_CENT_AVDD_SLOPE_INACTIVE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SEQUENCE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SEQUENCE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_IS_BIFURCATABLE, AttrMetadataStr(sizeof(ATTR_PEC_IS_BIFURCATABLE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_INIT_PHY_VREF, AttrMetadataStr(sizeof(ATTR_MEM_EXP_INIT_PHY_VREF_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FORCE_SYNC_SS_PLL_SPREAD, AttrMetadataStr(sizeof(ATTR_FORCE_SYNC_SS_PLL_SPREAD_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_X_EREPAIR_THRESHOLD_MNFG, AttrMetadataStr(sizeof(ATTR_X_EREPAIR_THRESHOLD_MNFG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_TEST_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_TEST_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_SELECT_BOOT_SEEPROM_IMAGE, AttrMetadataStr(sizeof(ATTR_PROC_SELECT_BOOT_SEEPROM_IMAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DISABLE_HBBL_VECTORS, AttrMetadataStr(sizeof(ATTR_DISABLE_HBBL_VECTORS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F4BC0x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F4BC0x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_SYS_CONFIG, AttrMetadataStr(sizeof(ATTR_SBE_SYS_CONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC12, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC12_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_TMPL_B_PACING, AttrMetadataStr(sizeof(ATTR_EXPLR_TMPL_B_PACING_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU0_PRI_CONFIG, AttrMetadataStr(sizeof(ATTR_PROC_NPU0_PRI_CONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_ASR, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_ASR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_TM, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_TM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_L2_HASPOWER, AttrMetadataStr(sizeof(ATTR_L2_HASPOWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CME_CHTM_TRACE_MEMORY_CONFIG, AttrMetadataStr(sizeof(ATTR_CME_CHTM_TRACE_MEMORY_CONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_OUTPUT_BUFFER, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_OUTPUT_BUFFER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_N_PLUS_ONE_MEM_POWER, AttrMetadataStr(sizeof(ATTR_N_PLUS_ONE_MEM_POWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_VERSION_INFO, AttrMetadataStr(sizeof(ATTR_SBE_VERSION_INFO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_FLAGS, AttrMetadataStr(sizeof(ATTR_MNFG_FLAGS_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_POUND_W_STATIC_DATA_ENABLE, AttrMetadataStr(sizeof(ATTR_POUND_W_STATIC_DATA_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MBA_ADDR_INTERLEAVE_BIT, AttrMetadataStr(sizeof(ATTR_MSS_MBA_ADDR_INTERLEAVE_BIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_OCMB_THERMAL_MEMORY_POWER_LIMIT, AttrMetadataStr(sizeof(ATTR_MSS_MRW_OCMB_THERMAL_MEMORY_POWER_LIMIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CLASS, AttrMetadataStr(sizeof(ATTR_CLASS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_MEMORY_IMPES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_MEMORY_IMPES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HB_HRMOR_BYTES, AttrMetadataStr(sizeof(ATTR_HB_HRMOR_BYTES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT16_ARRAY_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT16_ARRAY_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_R_LOADLINE_VCS_UOHM, AttrMetadataStr(sizeof(ATTR_PROC_R_LOADLINE_VCS_UOHM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_MODE_DIS_TSTAMP, AttrMetadataStr(sizeof(ATTR_HTMSC_MODE_DIS_TSTAMP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_WOV_UNDERV_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_WOV_UNDERV_DISABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_PWR_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_MRW_PWR_INTERCEPT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_POST_MEMDIAGS_READ_SUBTEST_FAIL_BEHAVIOR, AttrMetadataStr(sizeof(ATTR_MSS_POST_MEMDIAGS_READ_SUBTEST_FAIL_BEHAVIOR_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HB_SETTINGS, AttrMetadataStr(sizeof(ATTR_HB_SETTINGS_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_CEN_MBA_RT_SOFT_CE_TH_ALGO, AttrMetadataStr(sizeof(ATTR_MNFG_TH_CEN_MBA_RT_SOFT_CE_TH_ALGO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_BRAND_NAME, AttrMetadataStr(sizeof(ATTR_SYSTEM_BRAND_NAME_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VTPM_ENABLED, AttrMetadataStr(sizeof(ATTR_VTPM_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TWTR, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TWTR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_MPR_RD_FORMAT, AttrMetadataStr(sizeof(ATTR_CEN_EFF_MPR_RD_FORMAT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FSI_SLAVE_CASCADE, AttrMetadataStr(sizeof(ATTR_FSI_SLAVE_CASCADE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_A_LINKS_CNFG, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_A_LINKS_CNFG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TLB_DATA_ENTRIES, AttrMetadataStr(sizeof(ATTR_TLB_DATA_ENTRIES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A07, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A07_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_SEEPROM_I2C_DEVICE_ADDRESS, AttrMetadataStr(sizeof(ATTR_SBE_SEEPROM_I2C_DEVICE_ADDRESS_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRCD, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRCD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_RD_VREF, AttrMetadataStr(sizeof(ATTR_CEN_EFF_RD_VREF_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_7x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_7x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_SMP_OPTICS_MODE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_SMP_OPTICS_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TWTR_L, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TWTR_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MGC_LOAD_SOURCE, AttrMetadataStr(sizeof(ATTR_MGC_LOAD_SOURCE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_IBM_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_IBM_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_PAT_A_CAPTURE, AttrMetadataStr(sizeof(ATTR_IO_OBUS_PAT_A_CAPTURE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_DENOMINATOR, AttrMetadataStr(sizeof(ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_DENOMINATOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_FREQ_OVERRIDE, AttrMetadataStr(sizeof(ATTR_MSS_FREQ_OVERRIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_N_MAX_MEM_POWER_WATTS, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_N_MAX_MEM_POWER_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_EFD_PMIC1_SWB_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_EFD_PMIC1_SWB_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKN, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DISABLE_I2C_ENGINE2_PORT0_DIAG_MODE, AttrMetadataStr(sizeof(ATTR_DISABLE_I2C_ENGINE2_PORT0_DIAG_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_DD1_SLOW_PCI_REF_CLOCK, AttrMetadataStr(sizeof(ATTR_DD1_SLOW_PCI_REF_CLOCK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_DIMM_MAXPOWER, AttrMetadataStr(sizeof(ATTR_MSS_DIMM_MAXPOWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_RESCLK_FREQ_REGIONS, AttrMetadataStr(sizeof(ATTR_SYSTEM_RESCLK_FREQ_REGIONS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TWRMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TWRMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_RTT_PARK, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_RTT_PARK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VREF_CAL_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_VREF_CAL_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_TCCD_L, AttrMetadataStr(sizeof(ATTR_CEN_TCCD_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_INIT_STATE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_INIT_STATE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_EXT_VDD_BIAS_ULTRATURBO, AttrMetadataStr(sizeof(ATTR_VOLTAGE_EXT_VDD_BIAS_ULTRATURBO_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_BOOT_CONFIG_DFE_DISABLE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_DFE_DISABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_VREF_MC_RD, AttrMetadataStr(sizeof(ATTR_MEM_SI_VREF_MC_RD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPL_ATTRIBUTES, AttrMetadataStr(sizeof(ATTR_IPL_ATTRIBUTES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DUMMY_WO, AttrMetadataStr(sizeof(ATTR_DUMMY_WO_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F0RC03, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F0RC03_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_VC_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_VC_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWD_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWD_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHIP_UNIT, AttrMetadataStr(sizeof(ATTR_CHIP_UNIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS2, AttrMetadataStr(sizeof(ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TEMP_SENSOR_I2C_CONFIG, AttrMetadataStr(sizeof(ATTR_TEMP_SENSOR_I2C_CONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC06, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC06_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_PLL_FREQ_I2CDIV_LIST, AttrMetadataStr(sizeof(ATTR_NEST_PLL_FREQ_I2CDIV_LIST_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BMC_HW_CHIP_TYPE, AttrMetadataStr(sizeof(ATTR_BMC_HW_CHIP_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_DCACHE_ASSOC_SETS, AttrMetadataStr(sizeof(ATTR_DCACHE_ASSOC_SETS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TRCMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TRCMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CA_PARITY_ERROR_STATUS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CA_PARITY_ERROR_STATUS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TIME_BASE, AttrMetadataStr(sizeof(ATTR_TIME_BASE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT32_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT32_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RNG_BAR_SIZE, AttrMetadataStr(sizeof(ATTR_RNG_BAR_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_THREAD_COUNT, AttrMetadataStr(sizeof(ATTR_THREAD_COUNT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_0_VERSION_LAYOUT, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_0_VERSION_LAYOUT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_LANE_EQUALIZATION_GEN3, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_LANE_EQUALIZATION_GEN3_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PRESERVE_MDC_PARTITION_VPD, AttrMetadataStr(sizeof(ATTR_PRESERVE_MDC_PARTITION_VPD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DUMP_STOP_INFO_SUPPRESS_ERROR_TRACE, AttrMetadataStr(sizeof(ATTR_DUMP_STOP_INFO_SUPPRESS_ERROR_TRACE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EPS_GB_PERCENTAGE, AttrMetadataStr(sizeof(ATTR_PROC_EPS_GB_PERCENTAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_WEN_A14, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_WEN_A14_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_ADDR_MODE, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_ADDR_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_DEFAULT_RISK_LEVEL, AttrMetadataStr(sizeof(ATTR_MRW_DEFAULT_RISK_LEVEL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_SELECT_SEEPROM_IMAGE, AttrMetadataStr(sizeof(ATTR_PROC_SELECT_SEEPROM_IMAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC03, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC03_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PULSE_MODE_ENABLE, AttrMetadataStr(sizeof(ATTR_PULSE_MODE_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_GEN, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_GEN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_8x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_8x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_VCS_SLOPE_INACTIVE, AttrMetadataStr(sizeof(ATTR_MSS_CENT_VCS_SLOPE_INACTIVE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_PAR, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_PAR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_VPP_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MEM_VPP_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC0E, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC0E_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU_MMIO_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_NPU_MMIO_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRPMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRPMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_DDR_REFCLOCK_RCVR_TERM, AttrMetadataStr(sizeof(ATTR_CEN_DDR_REFCLOCK_RCVR_TERM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_QUATERNARY_RANK_GROUP2, AttrMetadataStr(sizeof(ATTR_CEN_EFF_QUATERNARY_RANK_GROUP2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_XBUS_MIN_EYE_WIDTH, AttrMetadataStr(sizeof(ATTR_MNFG_XBUS_MIN_EYE_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_PER_DRAM_ACCESS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_PER_DRAM_ACCESS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_RANK_GROUP_OVERRIDE, AttrMetadataStr(sizeof(ATTR_EFF_RANK_GROUP_OVERRIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU_REGION_ENABLED, AttrMetadataStr(sizeof(ATTR_PROC_NPU_REGION_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_SOCKET_POWER_WATTS, AttrMetadataStr(sizeof(ATTR_PROC_SOCKET_POWER_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_THERMAL_AND_REFRESH_OPTIONS, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_THERMAL_AND_REFRESH_OPTIONS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_MIN_MEM_UTILIZATION_POWER_CAP, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_MIN_MEM_UTILIZATION_POWER_CAP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRC, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_MT, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_MT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWB_SEQUENCE_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWB_SEQUENCE_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_ENGINE, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_ENGINE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F1RC04, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F1RC04_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DIMM_RCD_IBT_CKE, AttrMetadataStr(sizeof(ATTR_MEM_SI_DIMM_RCD_IBT_CKE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_XIVE_CONTROLLER_BAR_ADDR, AttrMetadataStr(sizeof(ATTR_XIVE_CONTROLLER_BAR_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A06, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A06_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CREATE_DEF_PARTITION, AttrMetadataStr(sizeof(ATTR_CREATE_DEF_PARTITION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_PREFETCH_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_PREFETCH_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OCMB_FW_UPDATE_OVERRIDE, AttrMetadataStr(sizeof(ATTR_OCMB_FW_UPDATE_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_DOWN, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_DOWN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT16_ARRAY_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT16_ARRAY_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_STRUCT_MMIO_ENDIAN_CTRL, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_STRUCT_MMIO_ENDIAN_CTRL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPS_ENABLE, AttrMetadataStr(sizeof(ATTR_IPS_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F5BC1x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F5BC1x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_WR_VREF_OFFSET, AttrMetadataStr(sizeof(ATTR_MSS_WR_VREF_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOF_ENABLE_VRATIO, AttrMetadataStr(sizeof(ATTR_WOF_ENABLE_VRATIO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DIMM_TYPE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DIMM_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_RECOV_OBJ_HANDLE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_RECOV_OBJ_HANDLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PCI_BASE_ADDRS_64, AttrMetadataStr(sizeof(ATTR_PCI_BASE_ADDRS_64_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_VREF_DQ_TRAIN_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_VREF_DQ_TRAIN_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_REQUIRED_SYNCH_MODE, AttrMetadataStr(sizeof(ATTR_REQUIRED_SYNCH_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_MEMCTRL_ERROR_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_MEMCTRL_ERROR_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EPS_READ_CYCLES_T2, AttrMetadataStr(sizeof(ATTR_PROC_EPS_READ_CYCLES_T2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_MMIO_BAR0_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_MMIO_BAR0_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F1RC03, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F1RC03_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_RCV_EQ_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_RCV_EQ_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F6BC0x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F6BC0x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PRIM_STACK_TYPE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PRIM_STACK_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHIP_ID, AttrMetadataStr(sizeof(ATTR_CHIP_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_VREF_DQ_TRAIN_VALUE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_VREF_DQ_TRAIN_VALUE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_DIMM_MAXBANDWIDTH_MRS, AttrMetadataStr(sizeof(ATTR_MSS_DIMM_MAXBANDWIDTH_MRS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_CTRL_MARK, AttrMetadataStr(sizeof(ATTR_NHTM_CTRL_MARK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F74BCAx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F74BCAx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_CACHE_INJ_MODE, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_CACHE_INJ_MODE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A03, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A03_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_MODULE_MFG_ID, AttrMetadataStr(sizeof(ATTR_MEM_EFF_MODULE_MFG_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CA_PARITY_LATENCY, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CA_PARITY_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_PASR, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_PASR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_DENSITY, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_DENSITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_DMI_PROC_DEBUG, AttrMetadataStr(sizeof(ATTR_IO_DMI_PROC_DEBUG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_SPD_TAA_MIN, AttrMetadataStr(sizeof(ATTR_MEM_EXP_SPD_TAA_MIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_TSYS_ADR, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_TSYS_ADR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_DPLL_DIVIDER, AttrMetadataStr(sizeof(ATTR_PROC_DPLL_DIVIDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWC_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWC_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_PCIE_LANE_MASK_NON_BIFURCATED, AttrMetadataStr(sizeof(ATTR_PEC_PCIE_LANE_MASK_NON_BIFURCATED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NHTM_BAR_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_PROC_NHTM_BAR_BASE_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_MEM_THROTTLED_N_COMMANDS_PER_SLOT, AttrMetadataStr(sizeof(ATTR_EXP_MEM_THROTTLED_N_COMMANDS_PER_SLOT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DEVICE_ID, AttrMetadataStr(sizeof(ATTR_DEVICE_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F74BC9x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F74BC9x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ROW_REPAIR_SUPPORTED_MRW, AttrMetadataStr(sizeof(ATTR_ROW_REPAIR_SUPPORTED_MRW_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_POS_ON_MEM_PORT, AttrMetadataStr(sizeof(ATTR_POS_ON_MEM_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PBAX_BRDCST_ID_VECTOR, AttrMetadataStr(sizeof(ATTR_PBAX_BRDCST_ID_VECTOR_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_CEN_MBA_IPL_SOFT_CE_TH_ALGO, AttrMetadataStr(sizeof(ATTR_MNFG_TH_CEN_MBA_IPL_SOFT_CE_TH_ALGO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_UP, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_IMP_DQ_DQS_PULL_UP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CLOCK_PLL_MUX0, AttrMetadataStr(sizeof(ATTR_CLOCK_PLL_MUX0_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_EXT_VDN_BIAS, AttrMetadataStr(sizeof(ATTR_VOLTAGE_EXT_VDN_BIAS_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DRAM_PREAMBLE, AttrMetadataStr(sizeof(ATTR_MEM_SI_DRAM_PREAMBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_LRDIMM_RANK_MULT_MODE, AttrMetadataStr(sizeof(ATTR_LRDIMM_RANK_MULT_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_PUMP_MODE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_PUMP_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_OCMB_PWR_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_MRW_OCMB_PWR_INTERCEPT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_8x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_8x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F74BCEx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F74BCEx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TPM_UNUSABLE, AttrMetadataStr(sizeof(ATTR_TPM_UNUSABLE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_MFG_MIN_EYE_WIDTH, AttrMetadataStr(sizeof(ATTR_IO_OMI_MFG_MIN_EYE_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_GLOBAL_FIR_TRACE_EN, AttrMetadataStr(sizeof(ATTR_PM_GLOBAL_FIR_TRACE_EN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ORDINAL_ID, AttrMetadataStr(sizeof(ATTR_ORDINAL_ID_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_RESCLK_STEP_DELAY, AttrMetadataStr(sizeof(ATTR_SYSTEM_RESCLK_STEP_DELAY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRRD_L, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRRD_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_THERMAL_SENSOR, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_THERMAL_SENSOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC0B, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC0B_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_X_AGGREGATE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_X_AGGREGATE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_N_PLUS_ONE_N_PER_CHIP, AttrMetadataStr(sizeof(ATTR_N_PLUS_ONE_N_PER_CHIP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_BOOT_CONFIG_OPENCAPI_LOOPBACK_TEST, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_OPENCAPI_LOOPBACK_TEST_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_UP, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_WR_UP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_TERTIARY_RANK_GROUP0, AttrMetadataStr(sizeof(ATTR_CEN_EFF_TERTIARY_RANK_GROUP0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_CRC_WR_LATENCY, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_CRC_WR_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_CAS_LATENCIES_SUPPORTED, AttrMetadataStr(sizeof(ATTR_CEN_SPD_CAS_LATENCIES_SUPPORTED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ATTN_AREA_2_ADDR, AttrMetadataStr(sizeof(ATTR_ATTN_AREA_2_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TFAWMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TFAWMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_1x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_1x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_OMI_CFG_ENDIAN_CTRL, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_OMI_CFG_ENDIAN_CTRL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_WINDAGE_RD_CTR, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_WINDAGE_RD_CTR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_TERTIARY_RANK_GROUP2, AttrMetadataStr(sizeof(ATTR_CEN_EFF_TERTIARY_RANK_GROUP2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_MEM_SENSOR_CACHE_ADDR_MAP, AttrMetadataStr(sizeof(ATTR_MRW_MEM_SENSOR_CACHE_ADDR_MAP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC14, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC14_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_MBA, AttrMetadataStr(sizeof(ATTR_CEN_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_MBA_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRRDSMIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRRDSMIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TCCDLMIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TCCDLMIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DATA_CACHE_LINE_SIZE, AttrMetadataStr(sizeof(ATTR_DATA_CACHE_LINE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CAL_STEP_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_CAL_STEP_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC0F, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC0F_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXTERNAL_VRM_TRANSITION_STABILIZATION_TIME_NS, AttrMetadataStr(sizeof(ATTR_EXTERNAL_VRM_TRANSITION_STABILIZATION_TIME_NS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC09, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC09_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT32_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT32_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_RTT_NOM_OVERRIDE_DISABLE, AttrMetadataStr(sizeof(ATTR_MSS_RTT_NOM_OVERRIDE_DISABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VREF_DAC_NIBBLE, AttrMetadataStr(sizeof(ATTR_MSS_VREF_DAC_NIBBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_DATE, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_DATE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TWTR_L, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TWTR_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VCS_I2C_BUSNUM, AttrMetadataStr(sizeof(ATTR_VCS_I2C_BUSNUM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_IMA_PDBAR_ADDR, AttrMetadataStr(sizeof(ATTR_HTMSC_IMA_PDBAR_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_RANK, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_RANK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OCC_LFIR, AttrMetadataStr(sizeof(ATTR_OCC_LFIR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EQ_INSIDE_SPECIAL_WAKEUP, AttrMetadataStr(sizeof(ATTR_EQ_INSIDE_SPECIAL_WAKEUP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_LARGE_FREQ_DROP_N_L_OVERRIDE, AttrMetadataStr(sizeof(ATTR_VDM_LARGE_FREQ_DROP_N_L_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDD_AVSBUS_RAIL, AttrMetadataStr(sizeof(ATTR_VDD_AVSBUS_RAIL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_ID_MODULE_SERIAL_NUMBER, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_ID_MODULE_SERIAL_NUMBER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CENTAUR_ECID_FRU_ID, AttrMetadataStr(sizeof(ATTR_CENTAUR_ECID_FRU_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_DEVICE_PURPOSE, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_DEVICE_PURPOSE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_POST_DRAM_INIT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_DDR4_VDDR_INTERCEPT_POST_DRAM_INIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_REGISTER_REV, AttrMetadataStr(sizeof(ATTR_MEM_EFF_REGISTER_REV_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_COMPUTE_NODES_PER_SYSTEM, AttrMetadataStr(sizeof(ATTR_MAX_COMPUTE_NODES_PER_SYSTEM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_IMA_PDBAR_SPLIT_CORE_MODE, AttrMetadataStr(sizeof(ATTR_HTMSC_IMA_PDBAR_SPLIT_CORE_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_DROOP_SMALL_OVERRIDE, AttrMetadataStr(sizeof(ATTR_VDM_DROOP_SMALL_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_MAX_POWERDOWN_MODE, AttrMetadataStr(sizeof(ATTR_EFF_MAX_POWERDOWN_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_RASN_A16, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CMD_ADDR_RASN_A16_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_GEARDOWN_MODE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_GEARDOWN_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_3x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_3x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_TYPE, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_DIMM_MAXBANDWIDTH_GBS, AttrMetadataStr(sizeof(ATTR_MSS_DIMM_MAXBANDWIDTH_GBS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_PROC_READ_TIMEOUT_SEC, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_PROC_READ_TIMEOUT_SEC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDN_AVSBUS_RAIL, AttrMetadataStr(sizeof(ATTR_VDN_AVSBUS_RAIL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_VRM_VOFFSET_VDN_UV, AttrMetadataStr(sizeof(ATTR_PROC_VRM_VOFFSET_VDN_UV_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_DUMMY_RO, AttrMetadataStr(sizeof(ATTR_DUMMY_RO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MIRROR_SIZES, AttrMetadataStr(sizeof(ATTR_PROC_MIRROR_SIZES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_INTERNAL_FFDC_ENABLE, AttrMetadataStr(sizeof(ATTR_SBE_INTERNAL_FFDC_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IVRM_VIN_MULTIPLIER, AttrMetadataStr(sizeof(ATTR_IVRM_VIN_MULTIPLIER_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_RD_PREAMBLE_TRAIN, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_RD_PREAMBLE_TRAIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_AVDD_OFFSET_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_AVDD_OFFSET_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_ENGINE_TYPE, AttrMetadataStr(sizeof(ATTR_ENGINE_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWA_SEQUENCE_ORDER, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWA_SEQUENCE_ORDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_ODT1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFFECTIVE_EC, AttrMetadataStr(sizeof(ATTR_EFFECTIVE_EC_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FABRIC_GROUP_ID, AttrMetadataStr(sizeof(ATTR_FABRIC_GROUP_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_BURST_LENGTH, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_BURST_LENGTH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_MEMCTRL_THROTTLE_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_MEMCTRL_THROTTLE_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_BL, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_BL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HOSTSVC_PLID, AttrMetadataStr(sizeof(ATTR_HOSTSVC_PLID_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_DPHY_RLO, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_DPHY_RLO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WAIT_N2, AttrMetadataStr(sizeof(ATTR_WAIT_N2_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EPS_TABLE_TYPE, AttrMetadataStr(sizeof(ATTR_PROC_EPS_TABLE_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_DENSITY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_DENSITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A12, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A12_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_WR_VREF, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_WR_VREF_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_CORE_MAX, AttrMetadataStr(sizeof(ATTR_FREQ_CORE_MAX_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT8_ARRAY_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT8_ARRAY_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PRIM_DIE_COUNT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PRIM_DIE_COUNT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_DATA_SEED, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_DATA_SEED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_MPR_LOC, AttrMetadataStr(sizeof(ATTR_EFF_MPR_LOC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_R_DISTLOSS_VCS_UOHM, AttrMetadataStr(sizeof(ATTR_PROC_R_DISTLOSS_VCS_UOHM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_SEEPROM_I2C_PORT, AttrMetadataStr(sizeof(ATTR_SBE_SEEPROM_I2C_PORT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT32_ARRAY_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT32_ARRAY_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRTPMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRTPMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_HTMSC_MODE_CAPTURE_LIMIT_MEM_ALLOCATION, AttrMetadataStr(sizeof(ATTR_NHTM_HTMSC_MODE_CAPTURE_LIMIT_MEM_ALLOCATION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_PHY_SEQ_REFRESH, AttrMetadataStr(sizeof(ATTR_MSS_PHY_SEQ_REFRESH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ASCII_VPD_LX_KEYWORD, AttrMetadataStr(sizeof(ATTR_ASCII_VPD_LX_KEYWORD_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_MRW_IS_PLANAR, AttrMetadataStr(sizeof(ATTR_MEM_MRW_IS_PLANAR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_REDUNDANT_CLOCKS, AttrMetadataStr(sizeof(ATTR_REDUNDANT_CLOCKS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHTM_HTMSC_MODE_CAPTURE, AttrMetadataStr(sizeof(ATTR_CHTM_HTMSC_MODE_CAPTURE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ICACHE_SIZE, AttrMetadataStr(sizeof(ATTR_ICACHE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_LINK_SPARE_MARK, AttrMetadataStr(sizeof(ATTR_IO_OBUS_LINK_SPARE_MARK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_DMI_PROC_TX_FFE_PRECURSOR, AttrMetadataStr(sizeof(ATTR_IO_DMI_PROC_TX_FFE_PRECURSOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PNOR_FLASH_WORKAROUNDS, AttrMetadataStr(sizeof(ATTR_PNOR_FLASH_WORKAROUNDS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_MFG_STRESS_PR_OFFSET_EVEN, AttrMetadataStr(sizeof(ATTR_IO_OMI_MFG_STRESS_PR_OFFSET_EVEN_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NX_RNG_FAILED_INT_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_NX_RNG_FAILED_INT_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_ROW_BITS, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_ROW_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_BOOT_CONFIG_FW_MODE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_FW_MODE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_ISDIMM_MBVPD_INDEX, AttrMetadataStr(sizeof(ATTR_CEN_ISDIMM_MBVPD_INDEX_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_PHASE_ROTATOR_CNTL, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_PHASE_ROTATOR_CNTL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VCS_PROGRAM, AttrMetadataStr(sizeof(ATTR_MSS_VCS_PROGRAM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_LPASR, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_LPASR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_RCD_SLEW_RATE, AttrMetadataStr(sizeof(ATTR_MEM_EXP_RCD_SLEW_RATE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DRV_IMP_CMD_ADDR, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DRV_IMP_CMD_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHTM_HTMSC_MODE_CORE_INSTR_STALL, AttrMetadataStr(sizeof(ATTR_CHTM_HTMSC_MODE_CORE_INSTR_STALL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWD_SEQUENCE_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWD_SEQUENCE_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_0_AVAIL, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_0_AVAIL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ROLE, AttrMetadataStr(sizeof(ATTR_ROLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT16_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT16_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_OVERV_STEP_DECR_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_OVERV_STEP_DECR_10THPCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_LANE_PDWN, AttrMetadataStr(sizeof(ATTR_IO_OBUS_LANE_PDWN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F6BC1x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F6BC1x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_2_SIGNATURE_HASH, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_2_SIGNATURE_HASH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_C1_PC_HASCLOCKS, AttrMetadataStr(sizeof(ATTR_C1_PC_HASCLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_DATABUS_UTIL, AttrMetadataStr(sizeof(ATTR_MSS_DATABUS_UTIL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_BANK_BITS, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_BANK_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_ENABLE_US_TMPL_1, AttrMetadataStr(sizeof(ATTR_EXPLR_ENABLE_US_TMPL_1_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MEM_WATT_TARGET, AttrMetadataStr(sizeof(ATTR_MSS_MEM_WATT_TARGET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CA_PARITY, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CA_PARITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_VC_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_VC_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TWTR_L, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TWTR_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_BIAS_POWERSAVE, AttrMetadataStr(sizeof(ATTR_FREQ_BIAS_POWERSAVE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC05, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC05_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_MEMCAL_INTERVAL, AttrMetadataStr(sizeof(ATTR_EFF_MEMCAL_INTERVAL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_POS_METADATA, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_POS_METADATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TRRDLMIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TRRDLMIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SAFE_FREQUENCY_MHZ, AttrMetadataStr(sizeof(ATTR_PM_SAFE_FREQUENCY_MHZ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHTM_CTRL_TRIG, AttrMetadataStr(sizeof(ATTR_CHTM_CTRL_TRIG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_PB_MHZ, AttrMetadataStr(sizeof(ATTR_FREQ_PB_MHZ_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F4BC4x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F4BC4x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F5BC0x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F5BC0x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_DLL_PPD, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_DLL_PPD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_VREF_DQ_TRAIN_VALUE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_VREF_DQ_TRAIN_VALUE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU_PHY1_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_NPU_PHY1_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TFAW_DLR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TFAW_DLR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VCS_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VCS_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CRC_WR_LATENCY, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CRC_WR_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MEM_IPL_COMPLETE, AttrMetadataStr(sizeof(ATTR_MSS_MEM_IPL_COMPLETE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_NVDIMM_IN_PORT, AttrMetadataStr(sizeof(ATTR_SBE_NVDIMM_IN_PORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_FILTER_BYPASS, AttrMetadataStr(sizeof(ATTR_IO_FILTER_BYPASS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_RESET_DELAY_BEFORE_CAL, AttrMetadataStr(sizeof(ATTR_MSS_MRW_RESET_DELAY_BEFORE_CAL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_PC_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_PC_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_POWERCAP_N_PER_CHIP, AttrMetadataStr(sizeof(ATTR_POWERCAP_N_PER_CHIP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_TM1_BAR_PAGE_SIZE, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_TM1_BAR_PAGE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WAIT_N1, AttrMetadataStr(sizeof(ATTR_WAIT_N1_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_VDD_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_CENT_VDD_INTERCEPT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_QUATERNARY_RANK_GROUP1, AttrMetadataStr(sizeof(ATTR_CEN_EFF_QUATERNARY_RANK_GROUP1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC00, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC00_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_VOLT_VPP, AttrMetadataStr(sizeof(ATTR_MEM_EFF_VOLT_VPP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_RANK_MIX, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_RANK_MIX_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC0F, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC0F_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BMC_MAX_ERROR_LOG_SIZE, AttrMetadataStr(sizeof(ATTR_BMC_MAX_ERROR_LOG_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRRD_S, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRRD_S_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TM, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_O_MFG_CHK, AttrMetadataStr(sizeof(ATTR_IO_O_MFG_CHK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_CTRL_XSTOP_STOP, AttrMetadataStr(sizeof(ATTR_HTMSC_CTRL_XSTOP_STOP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_REORDER_QUEUE_SETTING, AttrMetadataStr(sizeof(ATTR_MSS_EXP_REORDER_QUEUE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F1RC02, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F1RC02_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FIELD_TH_P8EX_L2_COL_REPAIRS, AttrMetadataStr(sizeof(ATTR_FIELD_TH_P8EX_L2_COL_REPAIRS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HYPERVISOR_IPL_SIDE, AttrMetadataStr(sizeof(ATTR_HYPERVISOR_IPL_SIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_DIFF_I2C_ADDR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_DIFF_I2C_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SLCA_RID, AttrMetadataStr(sizeof(ATTR_SLCA_RID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_RCD_MFG_ID, AttrMetadataStr(sizeof(ATTR_MEM_EFF_RCD_MFG_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_FINE_REFRESH_MODE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_FINE_REFRESH_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_MALF_CYCLE, AttrMetadataStr(sizeof(ATTR_PM_MALF_CYCLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRCD, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRCD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_RANKS_CONFIGED, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_RANKS_CONFIGED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_SYSTEM_MASTER_CHIP, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_SYSTEM_MASTER_CHIP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DUMP_STOP_INFO_ENABLE_ERRORLOG, AttrMetadataStr(sizeof(ATTR_DUMP_STOP_INFO_ENABLE_ERRORLOG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MEM_MVPD_FWMS, AttrMetadataStr(sizeof(ATTR_MSS_MEM_MVPD_FWMS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_OPTICS_CONFIG_MODE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_OPTICS_CONFIG_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_MPR_MODE, AttrMetadataStr(sizeof(ATTR_EFF_MPR_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMGT_SAVED_POWER_LIMIT, AttrMetadataStr(sizeof(ATTR_HTMGT_SAVED_POWER_LIMIT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FSP_MMIO_MASK_SIZE, AttrMetadataStr(sizeof(ATTR_PROC_FSP_MMIO_MASK_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_POWER_INT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_POWER_INT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT32_ARRAY_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT32_ARRAY_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_IOVALID_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_IOVALID_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_OUTPUT_BUFFER, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_OUTPUT_BUFFER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SAFE_MODE_FREQUENCY_MHZ, AttrMetadataStr(sizeof(ATTR_SAFE_MODE_FREQUENCY_MHZ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_HTMSC_MODE_CAPTURE_PRECISE_CRESP_MODE, AttrMetadataStr(sizeof(ATTR_NHTM_HTMSC_MODE_CAPTURE_PRECISE_CRESP_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_TX_FFE_PRECURSOR, AttrMetadataStr(sizeof(ATTR_IO_OBUS_TX_FFE_PRECURSOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRCMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRCMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DPLL_BYPASS, AttrMetadataStr(sizeof(ATTR_DPLL_BYPASS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_PORT, AttrMetadataStr(sizeof(ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_PORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKP, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_D0_CLKP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_2_SIGNATURE_HASH, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_2_SIGNATURE_HASH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_RELEASE_TAG, AttrMetadataStr(sizeof(ATTR_SBE_RELEASE_TAG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_CA_PARITY_ERROR_STATUS, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_CA_PARITY_ERROR_STATUS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_DRAM_RTT_NOM, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_DRAM_RTT_NOM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_TX_DCLCK_ROT, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_TX_DCLCK_ROT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VREF_CAL_DELTA_FROM_NOMINAL, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VREF_CAL_DELTA_FROM_NOMINAL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_IVRM_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_IVRM_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EFF_WR_CRC, AttrMetadataStr(sizeof(ATTR_MSS_EFF_WR_CRC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC09, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC09_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IS_SIMULATION, AttrMetadataStr(sizeof(ATTR_IS_SIMULATION_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_CHIP, AttrMetadataStr(sizeof(ATTR_CEN_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_CHIP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SKIP_WAKEUP, AttrMetadataStr(sizeof(ATTR_SKIP_WAKEUP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_FREQ, AttrMetadataStr(sizeof(ATTR_MEM_EFF_FREQ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU2_MMIO_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_NPU2_MMIO_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_O_CHANNEL_TYPE, AttrMetadataStr(sizeof(ATTR_IO_O_CHANNEL_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_TX_PCIE_RECV_DETECT_CNTL_REG2, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_TX_PCIE_RECV_DETECT_CNTL_REG2_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PSI_BRIDGE_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_PSI_BRIDGE_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_INTERNAL_VREF_MONITOR, AttrMetadataStr(sizeof(ATTR_EFF_INTERNAL_VREF_MONITOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_IMA_PDBAR_SCOPE, AttrMetadataStr(sizeof(ATTR_HTMSC_IMA_PDBAR_SCOPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_STOP11_DISABLE, AttrMetadataStr(sizeof(ATTR_STOP11_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC0B, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC0B_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_WR_EYE_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_WR_EYE_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_TMPL_7_PACING, AttrMetadataStr(sizeof(ATTR_PROC_TMPL_7_PACING_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_EFD_PMIC1_SWA_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_EFD_PMIC1_SWA_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_TYPE_METADATA, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_TYPE_METADATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT16_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT16_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F74BCCx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F74BCCx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_OUTPUT_BUFFER, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_OUTPUT_BUFFER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRTP, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRTP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_1_I2C_ADDR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_1_I2C_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F4BC1x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F4BC1x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OBUS_RATIO_VALUE, AttrMetadataStr(sizeof(ATTR_OBUS_RATIO_VALUE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHIPLET_ID, AttrMetadataStr(sizeof(ATTR_CHIPLET_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXECUTION_PLATFORM, AttrMetadataStr(sizeof(ATTR_EXECUTION_PLATFORM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRC, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_CA_PARITY_ERROR_STATUS, AttrMetadataStr(sizeof(ATTR_EFF_CA_PARITY_ERROR_STATUS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_DRAM_MANUFACTURER_JEDEC_ID_CODE, AttrMetadataStr(sizeof(ATTR_CEN_SPD_DRAM_MANUFACTURER_JEDEC_ID_CODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F74BCFx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F74BCFx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ICACHE_BLOCK_SIZE, AttrMetadataStr(sizeof(ATTR_ICACHE_BLOCK_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC06_07, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC06_07_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PSTATES_ENABLED, AttrMetadataStr(sizeof(ATTR_PSTATES_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_N_PLUS_ONE_MAX_MEM_POWER_WATTS, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_N_PLUS_ONE_MAX_MEM_POWER_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IMT_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_IMT_BASE_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_PCIE_HX_KEYWORD_DATA, AttrMetadataStr(sizeof(ATTR_PEC_PCIE_HX_KEYWORD_DATA_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_MPR_RD_FORMAT, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_MPR_RD_FORMAT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F30BC3x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F30BC3x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_AL, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_AL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SKIP_RD_VREF_VREFSENSE_OVERRIDE, AttrMetadataStr(sizeof(ATTR_SKIP_RD_VREF_VREFSENSE_OVERRIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_DCCAL_FLAGS, AttrMetadataStr(sizeof(ATTR_IO_OBUS_DCCAL_FLAGS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MFG_WRAP_TEST_ABUS_LINKS_SET_ENABLE, AttrMetadataStr(sizeof(ATTR_MFG_WRAP_TEST_ABUS_LINKS_SET_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MISC_SYSTEM_COMPONENTS_MAX_POWER_WATTS, AttrMetadataStr(sizeof(ATTR_MISC_SYSTEM_COMPONENTS_MAX_POWER_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU0_MMIO_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_NPU0_MMIO_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_C0_EXEC_HASCLOCKS, AttrMetadataStr(sizeof(ATTR_C0_EXEC_HASCLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_RD_GATE_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_RD_GATE_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F6BC4x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F6BC4x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_HW_MIRRORING_ENABLE, AttrMetadataStr(sizeof(ATTR_MRW_HW_MIRRORING_ENABLE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EPS_WRITE_CYCLES_T1, AttrMetadataStr(sizeof(ATTR_PROC_EPS_WRITE_CYCLES_T1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_PCIE_IOP_REVERSAL_BIFURCATED, AttrMetadataStr(sizeof(ATTR_PEC_PCIE_IOP_REVERSAL_BIFURCATED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRCDMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRCDMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_GEN, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_GEN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_DIMMS_PER_MBA_PORT, AttrMetadataStr(sizeof(ATTR_MAX_DIMMS_PER_MBA_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_SAFEMODE_MEM_THROTTLED_N_COMMANDS_PER_PORT, AttrMetadataStr(sizeof(ATTR_MSS_MRW_SAFEMODE_MEM_THROTTLED_N_COMMANDS_PER_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDN_BOOT_VOLTAGE, AttrMetadataStr(sizeof(ATTR_VDN_BOOT_VOLTAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NPU_MMIO_BAR_SIZE, AttrMetadataStr(sizeof(ATTR_NPU_MMIO_BAR_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EC, AttrMetadataStr(sizeof(ATTR_EC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_CHIP, AttrMetadataStr(sizeof(ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_CHIP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_CL, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_CL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_REPORT_THROTTLE_BELOW_NOMINAL, AttrMetadataStr(sizeof(ATTR_REPORT_THROTTLE_BELOW_NOMINAL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FSI_MASTER_CHIP, AttrMetadataStr(sizeof(ATTR_FSI_MASTER_CHIP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_I2C_CONTROL_INFO, AttrMetadataStr(sizeof(ATTR_I2C_CONTROL_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_FIRMWARE_EMULATION_MODE, AttrMetadataStr(sizeof(ATTR_MEM_EXP_FIRMWARE_EMULATION_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_FILT_CRESP_MASK, AttrMetadataStr(sizeof(ATTR_HTMSC_FILT_CRESP_MASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_0_TYPE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_0_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDDW_ORDER, AttrMetadataStr(sizeof(ATTR_HDDW_ORDER_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_SIZE, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_SLEW_RATE_ADDR_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_SLEW_RATE_ADDR_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SPWUP_IGNORE_XSTOP_FLAG, AttrMetadataStr(sizeof(ATTR_PM_SPWUP_IGNORE_XSTOP_FLAG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_DLL_RESET, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_DLL_RESET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_INTERLEAVE_GRANULARITY, AttrMetadataStr(sizeof(ATTR_MSS_INTERLEAVE_GRANULARITY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_O_MFG_STRESS_PR_OFFSET_ODD, AttrMetadataStr(sizeof(ATTR_IO_O_MFG_STRESS_PR_OFFSET_ODD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_P8EX_L3_CACHE_CES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_P8EX_L3_CACHE_CES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHTM_TRACE_TYPE, AttrMetadataStr(sizeof(ATTR_CHTM_TRACE_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A13, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A13_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_WINDAGE_RD_CTR, AttrMetadataStr(sizeof(ATTR_MEM_SI_WINDAGE_RD_CTR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_FFDC_ENABLE, AttrMetadataStr(sizeof(ATTR_SBE_FFDC_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_SBE_SEEPROM_SIZE, AttrMetadataStr(sizeof(ATTR_MAX_SBE_SEEPROM_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_TOTAL_PWR_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_TOTAL_PWR_INTERCEPT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FUSED_CORE_MODE_HB, AttrMetadataStr(sizeof(ATTR_FUSED_CORE_MODE_HB_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_OCMB_CURRENT_CURVE_WITH_LIMIT, AttrMetadataStr(sizeof(ATTR_MSS_MRW_OCMB_CURRENT_CURVE_WITH_LIMIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_OMI_OC_MAJOR_VER, AttrMetadataStr(sizeof(ATTR_PROC_OMI_OC_MAJOR_VER_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_TCE_START_TOKEN_FOR_HDAT, AttrMetadataStr(sizeof(ATTR_TCE_START_TOKEN_FOR_HDAT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_QUATERNARY_RANK_GROUP3, AttrMetadataStr(sizeof(ATTR_CEN_EFF_QUATERNARY_RANK_GROUP3_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PULSE_MODE_VALUE, AttrMetadataStr(sizeof(ATTR_PULSE_MODE_VALUE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_VPP_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_VPP_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC0B, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC0B_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_STOP5_DISABLE, AttrMetadataStr(sizeof(ATTR_STOP5_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_DPLL_REFCLOCK_KHZ, AttrMetadataStr(sizeof(ATTR_FREQ_DPLL_REFCLOCK_KHZ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_RTT_WR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_RTT_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ADC_CHANNEL_GNDS, AttrMetadataStr(sizeof(ATTR_ADC_CHANNEL_GNDS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TREFI, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TREFI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_MR, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_MR_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_RD_UP, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DQ_ACBOOST_RD_UP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_X_ATTACHED_CHIP_CNFG, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_X_ATTACHED_CHIP_CNFG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TWR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TWR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_MEM_PRIORITY, AttrMetadataStr(sizeof(ATTR_HTMSC_MEM_PRIORITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_AVDD_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_AVDD_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_DEVICE_TYPE_SIGNAL_LOADING, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_DEVICE_TYPE_SIGNAL_LOADING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F0RC02, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F0RC02_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_NUM_MASTER_RANKS_PER_DIMM, AttrMetadataStr(sizeof(ATTR_EFF_NUM_MASTER_RANKS_PER_DIMM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDD_CURRENT_OVERFLOW_WORKAROUND_ENABLE, AttrMetadataStr(sizeof(ATTR_VDD_CURRENT_OVERFLOW_WORKAROUND_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DIMM_RCD_IBT_CS, AttrMetadataStr(sizeof(ATTR_MEM_SI_DIMM_RCD_IBT_CS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_CORE_CEILING_RATIO, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_CORE_CEILING_RATIO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_READ_DBI, AttrMetadataStr(sizeof(ATTR_CEN_EFF_READ_DBI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_Ax, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_Ax_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC04, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC04_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_SLEW_RATE_DATA, AttrMetadataStr(sizeof(ATTR_MSS_SLEW_RATE_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_ADDR_MAP_REG_TO_DRAM, AttrMetadataStr(sizeof(ATTR_CEN_SPD_ADDR_MAP_REG_TO_DRAM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PGPE_HCODE_FUNCTION_ENABLE, AttrMetadataStr(sizeof(ATTR_PGPE_HCODE_FUNCTION_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_ENABLE_US_TMPL_9, AttrMetadataStr(sizeof(ATTR_EXPLR_ENABLE_US_TMPL_9_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_L2_CACHE_SIZE, AttrMetadataStr(sizeof(ATTR_L2_CACHE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_EFD_PMIC0_SWD_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_EFD_PMIC0_SWD_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU_MMIO_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_NPU_MMIO_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_EXT_VCS_BIAS, AttrMetadataStr(sizeof(ATTR_VOLTAGE_EXT_VCS_BIAS_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_XBUS_GRP0_PRE_BAD_LANE_DATA, AttrMetadataStr(sizeof(ATTR_IO_XBUS_GRP0_PRE_BAD_LANE_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IMT_BAR_SIZE, AttrMetadataStr(sizeof(ATTR_IMT_BAR_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEER_TARGET, AttrMetadataStr(sizeof(ATTR_PEER_TARGET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPS_EXIT_UTILIZATION_PERCENT, AttrMetadataStr(sizeof(ATTR_IPS_EXIT_UTILIZATION_PERCENT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_VCS_SLOPE_ACTIVE, AttrMetadataStr(sizeof(ATTR_MSS_CENT_VCS_SLOPE_ACTIVE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_P8EX_L2_DIR_CES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_P8EX_L2_DIR_CES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOF_POWER_LIMIT, AttrMetadataStr(sizeof(ATTR_WOF_POWER_LIMIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_KEY_TRANSITION_STATE, AttrMetadataStr(sizeof(ATTR_KEY_TRANSITION_STATE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A05, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A05_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_R_DISTLOSS_VDD_UOHM, AttrMetadataStr(sizeof(ATTR_PROC_R_DISTLOSS_VDD_UOHM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRRDMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRRDMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_RDIMM_BUFFER_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_RDIMM_BUFFER_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWA_SEQUENCE_DELAY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWA_SEQUENCE_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IBSCOM_PROC_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_IBSCOM_PROC_BASE_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_TEMP_READOUT, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_TEMP_READOUT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_CRC_MNFG_SEC_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_CRC_MNFG_SEC_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SELF_REF_ABORT, AttrMetadataStr(sizeof(ATTR_EFF_SELF_REF_ABORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_REVISION, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_REVISION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_DQ_MAP, AttrMetadataStr(sizeof(ATTR_MSS_VPD_DQ_MAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_SLEW_RATE_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_VREF_DQ_TRAIN_RANGE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_VREF_DQ_TRAIN_RANGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_REFCLOCK_RCVR_TERM, AttrMetadataStr(sizeof(ATTR_IO_REFCLOCK_RCVR_TERM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_L2_CACHE_LINE_SIZE, AttrMetadataStr(sizeof(ATTR_L2_CACHE_LINE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F0BCCx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F0BCCx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRAS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRAS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_PWR_SLOPE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_PWR_SLOPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_OCC_SANDBOX_SIZE, AttrMetadataStr(sizeof(ATTR_PROC_OCC_SANDBOX_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PBAX_CHIPID, AttrMetadataStr(sizeof(ATTR_PBAX_CHIPID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_SIGDET_CNTL, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_SIGDET_CNTL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CAL_ABORT_ON_ERROR, AttrMetadataStr(sizeof(ATTR_MSS_CAL_ABORT_ON_ERROR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_VC_BAR_BASE_ADDR_OFFSET_MASK, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_VC_BAR_BASE_ADDR_OFFSET_MASK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWC_SEQUENCE_ORDER, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWC_SEQUENCE_ORDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TARGET_HAS_CLOCK, AttrMetadataStr(sizeof(ATTR_TARGET_HAS_CLOCK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC02, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC02_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_TERTIARY_RANK_GROUP3, AttrMetadataStr(sizeof(ATTR_CEN_EFF_TERTIARY_RANK_GROUP3_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MEM_MC_IN_GROUP, AttrMetadataStr(sizeof(ATTR_MSS_MEM_MC_IN_GROUP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_ROWS, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_ROWS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F0RC05, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F0RC05_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FABRIC_PRESENT_GROUPS, AttrMetadataStr(sizeof(ATTR_FABRIC_PRESENT_GROUPS_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VDD_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VDD_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_SLEW_RATE_CNTL_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_SLEW_RATE_CNTL_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU2_MMIO_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_NPU2_MMIO_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HWAS_STATE_CHANGED_SUBSCRIPTION_MASK, AttrMetadataStr(sizeof(ATTR_HWAS_STATE_CHANGED_SUBSCRIPTION_MASK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_OMI_OC_MINOR_VER, AttrMetadataStr(sizeof(ATTR_PROC_OMI_OC_MINOR_VER_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_UNSECURE_HOMER_SIZE, AttrMetadataStr(sizeof(ATTR_UNSECURE_HOMER_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_PROC_REFCLOCK_KHZ, AttrMetadataStr(sizeof(ATTR_FREQ_PROC_REFCLOCK_KHZ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_AUX_FUNC_INVOCATION_TIME_MS, AttrMetadataStr(sizeof(ATTR_AUX_FUNC_INVOCATION_TIME_MS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_POUNDV_BUCKET_NUM_OVERRIDE, AttrMetadataStr(sizeof(ATTR_POUNDV_BUCKET_NUM_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VPP_INTERCEPT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VPP_INTERCEPT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC01, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC01_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_NUM_MASTER_RANKS_PER_DIMM, AttrMetadataStr(sizeof(ATTR_MEM_EFF_NUM_MASTER_RANKS_PER_DIMM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_SLOT, AttrMetadataStr(sizeof(ATTR_MSS_MEM_THROTTLED_N_COMMANDS_PER_SLOT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ENLARGED_IO_SLOT_COUNT, AttrMetadataStr(sizeof(ATTR_ENLARGED_IO_SLOT_COUNT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FIELD_TH_P8EX_L2_LINE_DELETES, AttrMetadataStr(sizeof(ATTR_FIELD_TH_P8EX_L2_LINE_DELETES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_RCD_MFG_ID, AttrMetadataStr(sizeof(ATTR_EFF_RCD_MFG_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WAIT_N3, AttrMetadataStr(sizeof(ATTR_WAIT_N3_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MC_SYNC_MODE, AttrMetadataStr(sizeof(ATTR_MC_SYNC_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_FAMILY, AttrMetadataStr(sizeof(ATTR_SYSTEM_FAMILY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_PAT_A_DETECT_RUN, AttrMetadataStr(sizeof(ATTR_IO_OBUS_PAT_A_DETECT_RUN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT8_ARRAY_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT8_ARRAY_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_TMPL_9_PACING, AttrMetadataStr(sizeof(ATTR_EXPLR_TMPL_9_PACING_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_DRAM_WIDTH, AttrMetadataStr(sizeof(ATTR_CEN_SPD_DRAM_WIDTH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_MT_ENABLE, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_MT_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_RCD_CNTL_WORD_0_15, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_RCD_CNTL_WORD_0_15_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_DIFF_USAGE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_DIFF_USAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_PLL_FREQ_BUCKETS, AttrMetadataStr(sizeof(ATTR_NEST_PLL_FREQ_BUCKETS_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_AFFINITY_PATH, AttrMetadataStr(sizeof(ATTR_AFFINITY_PATH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_AVDD_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_CAPI_MODE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_CAPI_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT16_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT16_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT, AttrMetadataStr(sizeof(ATTR_MSS_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_AVSBUS_FREQUENCY, AttrMetadataStr(sizeof(ATTR_AVSBUS_FREQUENCY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_O_DEBUG, AttrMetadataStr(sizeof(ATTR_IO_O_DEBUG_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CENT_VDD_SLOPE_INACTIVE, AttrMetadataStr(sizeof(ATTR_MSS_CENT_VDD_SLOPE_INACTIVE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_ROT_CDR_LOOKAHEAD, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_ROT_CDR_LOOKAHEAD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_VDN_ID, AttrMetadataStr(sizeof(ATTR_NEST_VDN_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_LRDIMM_TRAINING_PATTERN, AttrMetadataStr(sizeof(ATTR_MSS_LRDIMM_TRAINING_PATTERN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_MODE_SINGLE_TSTAMP, AttrMetadataStr(sizeof(ATTR_HTMSC_MODE_SINGLE_TSTAMP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_VGA_CONTRL_REGISTER3, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_VGA_CONTRL_REGISTER3_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_CA_PARITY_LATENCY, AttrMetadataStr(sizeof(ATTR_MEM_CA_PARITY_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_CCSM_MODE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_CCSM_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TM, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BOOT_FLAGS, AttrMetadataStr(sizeof(ATTR_BOOT_FLAGS_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU_PHY1_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_NPU_PHY1_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC04, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC04_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ICACHE_LINE_SIZE, AttrMetadataStr(sizeof(ATTR_ICACHE_LINE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_RTT_NOM, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_RTT_NOM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RESOURCE_IS_CRITICAL, AttrMetadataStr(sizeof(ATTR_RESOURCE_IS_CRITICAL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_POWER_CONTROL_REQUESTED, AttrMetadataStr(sizeof(ATTR_MSS_MRW_POWER_CONTROL_REQUESTED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_NUM_COLS, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_NUM_COLS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MBA_CACHELINE_INTERLEAVE_MODE, AttrMetadataStr(sizeof(ATTR_MSS_MBA_CACHELINE_INTERLEAVE_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_PREAMBLE, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_PREAMBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HUID, AttrMetadataStr(sizeof(ATTR_HUID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F74BCDx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F74BCDx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_MODE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TIMEBASE_MTB_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TIMEBASE_MTB_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_CTRL_DBG1_STOP, AttrMetadataStr(sizeof(ATTR_HTMSC_CTRL_DBG1_STOP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_N_PLUS_ONE_BULK_POWER_LIMIT_WATTS, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_N_PLUS_ONE_BULK_POWER_LIMIT_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_VREF_DRAM_WR, AttrMetadataStr(sizeof(ATTR_MEM_SI_VREF_DRAM_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DIMM_SPARE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DIMM_SPARE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_BYTE_ENABLES, AttrMetadataStr(sizeof(ATTR_MEM_EFF_BYTE_ENABLES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PAYLOAD_BASE, AttrMetadataStr(sizeof(ATTR_PAYLOAD_BASE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_DDR3_VDDR_SLOPE, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_DDR3_VDDR_SLOPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_RTT_NOM, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_RTT_NOM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DDR4_VDDR_SLOPE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DDR4_VDDR_SLOPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_PORT_POS_OF_FAIL_THROTTLE, AttrMetadataStr(sizeof(ATTR_MEM_PORT_POS_OF_FAIL_THROTTLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_ATXDLY_B, AttrMetadataStr(sizeof(ATTR_MEM_EFF_ATXDLY_B_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EARLY_TESTCASES_ISTEP, AttrMetadataStr(sizeof(ATTR_EARLY_TESTCASES_ISTEP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F5BC6x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F5BC6x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWC_VOLTAGE_RANGE_SELECT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWC_VOLTAGE_RANGE_SELECT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_PROC_WEIGHT, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_PROC_WEIGHT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_TPM_MODEL, AttrMetadataStr(sizeof(ATTR_TPM_MODEL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IVRM_DEADZONE_MV, AttrMetadataStr(sizeof(ATTR_IVRM_DEADZONE_MV_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC05, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC05_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F1RC05, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F1RC05_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_LRDIMM_ADDITIONAL_CNTL_WORDS, AttrMetadataStr(sizeof(ATTR_LRDIMM_ADDITIONAL_CNTL_WORDS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_WIDTH, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_WIDTH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_VDM_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_VDM_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_EFD_PMIC0_SWA_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_EFD_PMIC0_SWA_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_REFCLOCK_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_REFCLOCK_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_IOP_SWAP, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_IOP_SWAP_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_ODT_WR, AttrMetadataStr(sizeof(ATTR_MEM_SI_ODT_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TDQS, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TDQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_LPC_CONSOLE_CNFG, AttrMetadataStr(sizeof(ATTR_LPC_CONSOLE_CNFG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_THROTTLE_CONTROL_RAS_WEIGHT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_THROTTLE_CONTROL_RAS_WEIGHT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_AVDD_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_AVDD_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_I2C_SWITCHES, AttrMetadataStr(sizeof(ATTR_I2C_SWITCHES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MB_BIT_RATE_DIVISOR_REFCLK, AttrMetadataStr(sizeof(ATTR_MB_BIT_RATE_DIVISOR_REFCLK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SMF_CONFIG, AttrMetadataStr(sizeof(ATTR_SMF_CONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWB_SEQUENCE_ORDER, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWB_SEQUENCE_ORDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_DIFF_TYPE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_DIFF_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MBA_DIMM, AttrMetadataStr(sizeof(ATTR_MBA_DIMM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_SOFT_MIN_PCAP_WATTS, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_SOFT_MIN_PCAP_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_MODES, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_MODES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_MFG_ID, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_MFG_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_TEMP_REFRESH_MODE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_TEMP_REFRESH_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRRD_DLR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRRD_DLR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_STEP_INCR_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_STEP_INCR_10THPCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_ADDRESS_MIRRORING, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_ADDRESS_MIRRORING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_SELF_REF_ABORT, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_SELF_REF_ABORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_XIVE_THREAD_MGMT1_BAR_ADDR, AttrMetadataStr(sizeof(ATTR_XIVE_THREAD_MGMT1_BAR_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_3x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_3x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TMAW, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TMAW_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EFF_DPHY_WLO, AttrMetadataStr(sizeof(ATTR_MSS_EFF_DPHY_WLO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_FOUR_RANK_MODE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_FOUR_RANK_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_CA_PARITY, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_CA_PARITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DMI_EREPAIR_THRESHOLD_FIELD, AttrMetadataStr(sizeof(ATTR_DMI_EREPAIR_THRESHOLD_FIELD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRAS, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRAS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_INIT_VREF_DQ, AttrMetadataStr(sizeof(ATTR_MEM_EXP_INIT_VREF_DQ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_MPR_MODE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_MPR_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_BANKGROUPS_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_BANKGROUPS_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC02, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC02_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_DQS_CLK_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_DQS_CLK_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_FREQ_BIAS_PERCENTAGE, AttrMetadataStr(sizeof(ATTR_MSS_FREQ_BIAS_PERCENTAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DECONFIG_GARDABLE, AttrMetadataStr(sizeof(ATTR_DECONFIG_GARDABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HB_RSV_MEM_NEXT_SECTION, AttrMetadataStr(sizeof(ATTR_HB_RSV_MEM_NEXT_SECTION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ADC_CHANNEL_OFFSETS, AttrMetadataStr(sizeof(ATTR_ADC_CHANNEL_OFFSETS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_POSITION, AttrMetadataStr(sizeof(ATTR_POSITION_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TFAW, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TFAW_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_PHY_INIT_MODE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_PHY_INIT_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DO_MSS_TRAINING_BAD_BITS, AttrMetadataStr(sizeof(ATTR_DO_MSS_TRAINING_BAD_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_HW_TOPOLOGY, AttrMetadataStr(sizeof(ATTR_PROC_HW_TOPOLOGY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRC, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CKE0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MIRROR_SIZES_ACK, AttrMetadataStr(sizeof(ATTR_PROC_MIRROR_SIZES_ACK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F74BC8x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F74BC8x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RECONFIG_LOOP_TESTS, AttrMetadataStr(sizeof(ATTR_RECONFIG_LOOP_TESTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TLB_INSTR_ENTRIES, AttrMetadataStr(sizeof(ATTR_TLB_INSTR_ENTRIES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SKIP_HW_VREF_CAL, AttrMetadataStr(sizeof(ATTR_SKIP_HW_VREF_CAL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SECUREBOOT_PROTECT_DECONFIGURED_TPM, AttrMetadataStr(sizeof(ATTR_SECUREBOOT_PROTECT_DECONFIGURED_TPM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_CS_CMD_LATENCY, AttrMetadataStr(sizeof(ATTR_EFF_CS_CMD_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPS_EXIT_TIME_SECONDS, AttrMetadataStr(sizeof(ATTR_IPS_EXIT_TIME_SECONDS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_BOOT_CONFIG_SERDES_FREQUENCY, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_SERDES_FREQUENCY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_DMI_REFCLOCK_SWIZZLE, AttrMetadataStr(sizeof(ATTR_DMI_REFCLOCK_SWIZZLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_CHIPLETS_PER_PROC, AttrMetadataStr(sizeof(ATTR_MAX_CHIPLETS_PER_PROC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_ENABLE_US_TMPL_B, AttrMetadataStr(sizeof(ATTR_EXPLR_ENABLE_US_TMPL_B_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_SBE_MASTER_CHIP, AttrMetadataStr(sizeof(ATTR_PROC_SBE_MASTER_CHIP_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS, AttrMetadataStr(sizeof(ATTR_MSS_CUSTOM_TRAINING_ADV_BACKUP_PATTERNS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F1RC02, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F1RC02_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_NUM_DROPS_PER_PORT, AttrMetadataStr(sizeof(ATTR_CEN_EFF_NUM_DROPS_PER_PORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXTERNAL_VRM_TRANSITION_RATE_DEC_UV_PER_US, AttrMetadataStr(sizeof(ATTR_EXTERNAL_VRM_TRANSITION_RATE_DEC_UV_PER_US_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_THROTTLE_CONTROL_CAS_WEIGHT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_THROTTLE_CONTROL_CAS_WEIGHT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_MAX_DRAM_DATABUS_UTIL, AttrMetadataStr(sizeof(ATTR_MSS_MRW_MAX_DRAM_DATABUS_UTIL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_TSV_8H_SUPPORT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_TSV_8H_SUPPORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OS_IPL_MODE, AttrMetadataStr(sizeof(ATTR_OS_IPL_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_PRIM_STACK_TYPE, AttrMetadataStr(sizeof(ATTR_EFF_PRIM_STACK_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FORCE_PRE_PAYLOAD_DRTM, AttrMetadataStr(sizeof(ATTR_FORCE_PRE_PAYLOAD_DRTM_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PHYS_PRES_FAKE_ASSERT, AttrMetadataStr(sizeof(ATTR_PHYS_PRES_FAKE_ASSERT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_PRIMARY_RANK_GROUP1, AttrMetadataStr(sizeof(ATTR_CEN_EFF_PRIMARY_RANK_GROUP1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_REDUNDANCY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_REDUNDANCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_LPC_BUS_ADDR, AttrMetadataStr(sizeof(ATTR_LPC_BUS_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_PHASE_COMB, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_PHASE_COMB_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IS_DRTM_MPIPL_HB, AttrMetadataStr(sizeof(ATTR_IS_DRTM_MPIPL_HB_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_SYSTEM_CNTL, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_SYSTEM_CNTL_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PHYP_SYSTEM_TYPE, AttrMetadataStr(sizeof(ATTR_PHYP_SYSTEM_TYPE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT, AttrMetadataStr(sizeof(ATTR_EXP_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_PORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_FMIN_OVERRIDE_KHZ, AttrMetadataStr(sizeof(ATTR_VDM_FMIN_OVERRIDE_KHZ_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT32_ARRAY_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT32_ARRAY_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_VREF_DRAM_WR, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_VREF_DRAM_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWC_VOLTAGE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWC_VOLTAGE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MBA_DIMM, AttrMetadataStr(sizeof(ATTR_CEN_MBA_DIMM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_ATXDLY_A, AttrMetadataStr(sizeof(ATTR_MEM_EFF_ATXDLY_A_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F1BCCx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F1BCCx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_SPECATTN_OBJ_HANDLE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_SPECATTN_OBJ_HANDLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPS_ENTER_TIME_SECONDS, AttrMetadataStr(sizeof(ATTR_IPS_ENTER_TIME_SECONDS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PARENT_DECONFIG_RULES, AttrMetadataStr(sizeof(ATTR_PARENT_DECONFIG_RULES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_SRT, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_SRT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_MDS, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_MDS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DO_ABUS_DECONFIG, AttrMetadataStr(sizeof(ATTR_DO_ABUS_DECONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PERV_BNDY_PLL_DATA, AttrMetadataStr(sizeof(ATTR_PROC_PERV_BNDY_PLL_DATA_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_THERMAL_MEMORY_POWER_LIMIT, AttrMetadataStr(sizeof(ATTR_CEN_MRW_THERMAL_MEMORY_POWER_LIMIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SAFE_MODE_VOLTAGE_MV, AttrMetadataStr(sizeof(ATTR_SAFE_MODE_VOLTAGE_MV_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_RESET_FFDC_ENABLE, AttrMetadataStr(sizeof(ATTR_PM_RESET_FFDC_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_ENTERPRISE_POLICY, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_ENTERPRISE_POLICY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SPIPSS_INTER_FRAME_DELAY_SETTING, AttrMetadataStr(sizeof(ATTR_PM_SPIPSS_INTER_FRAME_DELAY_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MIN_FREQ_MHZ, AttrMetadataStr(sizeof(ATTR_MIN_FREQ_MHZ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_IC_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_IC_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FSP_BAR_SIZE, AttrMetadataStr(sizeof(ATTR_PROC_FSP_BAR_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_BIAS_TRIM, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_BIAS_TRIM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_PROC_ERROR_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_PROC_ERROR_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_LANE_EQUALIZATION_GEN4, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_LANE_EQUALIZATION_GEN4_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_AVDD_PROGRAM, AttrMetadataStr(sizeof(ATTR_MSS_AVDD_PROGRAM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_TMPL_0_PACING, AttrMetadataStr(sizeof(ATTR_EXPLR_TMPL_0_PACING_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC15, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC15_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_DMI_CEN_TX_MARGIN_RATIO, AttrMetadataStr(sizeof(ATTR_IO_DMI_CEN_TX_MARGIN_RATIO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NUMERIC_POD_TYPE_TEST, AttrMetadataStr(sizeof(ATTR_NUMERIC_POD_TYPE_TEST_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_PROC_REFCLOCK, AttrMetadataStr(sizeof(ATTR_FREQ_PROC_REFCLOCK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_DUMMY_RW, AttrMetadataStr(sizeof(ATTR_DUMMY_RW_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_OPTIONAL_FEATURES, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_OPTIONAL_FEATURES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_NIBBLE_MAP, AttrMetadataStr(sizeof(ATTR_MEM_EFF_NIBBLE_MAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BMC_MANUFACTURER, AttrMetadataStr(sizeof(ATTR_BMC_MANUFACTURER_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_DMI_PROC_TX_MARGIN_RATIO, AttrMetadataStr(sizeof(ATTR_IO_DMI_PROC_TX_MARGIN_RATIO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_XBUS_GRP1_PRE_BAD_LANE_DATA, AttrMetadataStr(sizeof(ATTR_IO_XBUS_GRP1_PRE_BAD_LANE_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_GPIO_INFO_PHYS_PRES, AttrMetadataStr(sizeof(ATTR_GPIO_INFO_PHYS_PRES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NVDIMM_ENCRYPTION_KEYS_ANCHOR, AttrMetadataStr(sizeof(ATTR_NVDIMM_ENCRYPTION_KEYS_ANCHOR_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_RESCLK_VALUE, AttrMetadataStr(sizeof(ATTR_SYSTEM_RESCLK_VALUE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OCC_MASTER_CAPABLE, AttrMetadataStr(sizeof(ATTR_OCC_MASTER_CAPABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HOMER_PHYS_ADDR, AttrMetadataStr(sizeof(ATTR_HOMER_PHYS_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DERIVED_MBA_ADDR_INTERLEAVE_BIT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DERIVED_MBA_ADDR_INTERLEAVE_BIT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_BANK_GROUP_BITS, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_BANK_GROUP_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_R_LOADLINE_VDD_UOHM, AttrMetadataStr(sizeof(ATTR_PROC_R_LOADLINE_VDD_UOHM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_IMP_CNTL, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_IMP_CNTL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_PRIM_DIE_COUNT, AttrMetadataStr(sizeof(ATTR_EFF_PRIM_DIE_COUNT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_PK_INIT, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_PK_INIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_MPR_MODE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_MPR_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_MODE_WRAP, AttrMetadataStr(sizeof(ATTR_HTMSC_MODE_WRAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_HYBRID, AttrMetadataStr(sizeof(ATTR_EFF_HYBRID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_OVERV_ENABLED, AttrMetadataStr(sizeof(ATTR_WOV_OVERV_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SAFE_VOLTAGE_MV, AttrMetadataStr(sizeof(ATTR_PM_SAFE_VOLTAGE_MV_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC01, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC01_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_MEM_THROTTLE_DENOMINATOR, AttrMetadataStr(sizeof(ATTR_CEN_MSS_MEM_THROTTLE_DENOMINATOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_XBUS_MASTER_MODE, AttrMetadataStr(sizeof(ATTR_IO_XBUS_MASTER_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A02, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A02_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TRPMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TRPMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CENTAUR_REGISTER_CACHE_PTR, AttrMetadataStr(sizeof(ATTR_CENTAUR_REGISTER_CACHE_PTR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_MAX_TIMEOUT, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_MAX_TIMEOUT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_CORECACHE_DCADJ_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_CORECACHE_DCADJ_DISABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_WIDTH, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_WIDTH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT8_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT8_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_CHECKSTOP_OBJ_HANDLE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_CHECKSTOP_OBJ_HANDLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_BOOT_CONFIG_TRANSPORT_LAYER, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_TRANSPORT_LAYER_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEER_PATH, AttrMetadataStr(sizeof(ATTR_PEER_PATH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_BIAS_TURBO, AttrMetadataStr(sizeof(ATTR_FREQ_BIAS_TURBO_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_FREQ_RETURN_L_S_OVERRIDE, AttrMetadataStr(sizeof(ATTR_VDM_FREQ_RETURN_L_S_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_RANKS_CONFIGED, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_RANKS_CONFIGED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CME_INSTRUCTION_TRACE_ENABLE, AttrMetadataStr(sizeof(ATTR_CME_INSTRUCTION_TRACE_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_REGULATOR_EFFICIENCY_FACTOR, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_REGULATOR_EFFICIENCY_FACTOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_TEMP_REF_RANGE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_TEMP_REF_RANGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_SUPPORTED_DRAM_WIDTH, AttrMetadataStr(sizeof(ATTR_MSS_MRW_SUPPORTED_DRAM_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IS_SLAVE_DRAWER, AttrMetadataStr(sizeof(ATTR_IS_SLAVE_DRAWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_X_LINKS_CNFG, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_X_LINKS_CNFG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_COLUMN_BITS, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_COLUMN_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_RANK, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_RANK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F74BCBx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F74BCBx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_MAX_NUMBER_DIMMS_POSSIBLE_PER_VMEM_REGULATOR, AttrMetadataStr(sizeof(ATTR_MSS_MRW_MAX_NUMBER_DIMMS_POSSIBLE_PER_VMEM_REGULATOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_MFG_ID, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_MFG_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DMI_INBAND_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_DMI_INBAND_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SPIPSS_FREQUENCY, AttrMetadataStr(sizeof(ATTR_SPIPSS_FREQUENCY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F1RC03, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F1RC03_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HB_HRMOR_NODAL_BASE, AttrMetadataStr(sizeof(ATTR_HB_HRMOR_NODAL_BASE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_OVERV_VMAX_SETPOINT_MV, AttrMetadataStr(sizeof(ATTR_WOV_OVERV_VMAX_SETPOINT_MV_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_SIGDET_LVL, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_SIGDET_LVL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRRD_S, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRRD_S_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_Bx, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_Bx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_SLEW_RATE_CNTL, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_SLEW_RATE_CNTL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT32_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT32_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRFC_DLR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRFC_DLR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_DATABUS_UTIL, AttrMetadataStr(sizeof(ATTR_EXP_DATABUS_UTIL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT64_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT64_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_MEM_WATT_TARGET, AttrMetadataStr(sizeof(ATTR_EXP_MEM_WATT_TARGET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ISTEP_MODE, AttrMetadataStr(sizeof(ATTR_ISTEP_MODE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OCC_CONTROL_DATA, AttrMetadataStr(sizeof(ATTR_OCC_CONTROL_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_LOFF_CONTROL, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_LOFF_CONTROL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_DPHY_WLO, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_DPHY_WLO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_NUM_DIES_PER_PACKAGE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_NUM_DIES_PER_PACKAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PHB_ACTIVE, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PHB_ACTIVE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_O_MFG_MIN_EYE_WIDTH, AttrMetadataStr(sizeof(ATTR_IO_O_MFG_MIN_EYE_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HW_VER, AttrMetadataStr(sizeof(ATTR_HW_VER_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NV_STATUS_FLAG, AttrMetadataStr(sizeof(ATTR_NV_STATUS_FLAG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_RON, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_RON_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_L3_HASCLOCKS, AttrMetadataStr(sizeof(ATTR_L3_HASCLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC04, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC04_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F0RC1X, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F0RC1X_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_WRITE_DBI, AttrMetadataStr(sizeof(ATTR_EFF_WRITE_DBI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOF_TABLE_LID_NUMBER, AttrMetadataStr(sizeof(ATTR_WOF_TABLE_LID_NUMBER_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_EFD_PMIC1_SWC_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_EFD_PMIC1_SWC_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_ROT_EXTEL, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_ROT_EXTEL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_POWERCAP_N_PER_MBA, AttrMetadataStr(sizeof(ATTR_POWERCAP_N_PER_MBA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_O_EREPAIR_THRESHOLD_MNFG, AttrMetadataStr(sizeof(ATTR_O_EREPAIR_THRESHOLD_MNFG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURERS_JEDEC_ID_CODE, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURERS_JEDEC_ID_CODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_WOF_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_WOF_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_FREQ_BIAS_PERCENTAGE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_FREQ_BIAS_PERCENTAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HB_RSV_MEM_SIZE_MB, AttrMetadataStr(sizeof(ATTR_HB_RSV_MEM_SIZE_MB_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PCIE_64BIT_DMA_SIZE, AttrMetadataStr(sizeof(ATTR_PCIE_64BIT_DMA_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F0BCFx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F0BCFx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_MEM_X_O_PCI_BYPASS, AttrMetadataStr(sizeof(ATTR_NEST_MEM_X_O_PCI_BYPASS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_CKE_MAP, AttrMetadataStr(sizeof(ATTR_MSS_VPD_CKE_MAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TCKMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TCKMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NO_APSS_PROC_POWER_VCS_VIO_WATTS, AttrMetadataStr(sizeof(ATTR_NO_APSS_PROC_POWER_VCS_VIO_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TFAW, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TFAW_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ATTN_AREA_1_ADDR, AttrMetadataStr(sizeof(ATTR_ATTN_AREA_1_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HWAS_STATE_CHANGED_FLAG, AttrMetadataStr(sizeof(ATTR_HWAS_STATE_CHANGED_FLAG_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_EFD_PMIC0_SWB_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_EFD_PMIC0_SWB_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_ABUS_MIN_EYE_WIDTH, AttrMetadataStr(sizeof(ATTR_MNFG_ABUS_MIN_EYE_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_ODT_RD, AttrMetadataStr(sizeof(ATTR_MEM_SI_ODT_RD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_BANKS, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_BANKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_VDD_OFFSET_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_VDD_OFFSET_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWB_SEQUENCE_ORDER, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWB_SEQUENCE_ORDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VDDR_OVERIDE_SPD, AttrMetadataStr(sizeof(ATTR_MSS_VDDR_OVERIDE_SPD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_ENABLED, AttrMetadataStr(sizeof(ATTR_VDM_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MEM_M_DRAM_CLOCKS, AttrMetadataStr(sizeof(ATTR_MSS_MEM_M_DRAM_CLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_SWITCHES, AttrMetadataStr(sizeof(ATTR_VPD_SWITCHES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_SUPPORTED_RCD, AttrMetadataStr(sizeof(ATTR_MEM_EFF_SUPPORTED_RCD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_XBUS_TX_MARGIN_RATIO, AttrMetadataStr(sizeof(ATTR_IO_XBUS_TX_MARGIN_RATIO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT8_ARRAY_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT8_ARRAY_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PHB_BASE_ADDRS, AttrMetadataStr(sizeof(ATTR_PHB_BASE_ADDRS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TREFI, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TREFI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_AL, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_AL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_USER_RANK, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_USER_RANK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DMI_INBAND_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_DMI_INBAND_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_LEN_OF_SEEPROM_DATA, AttrMetadataStr(sizeof(ATTR_LEN_OF_SEEPROM_DATA_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_PRINT_PORT, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_PRINT_PORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_RANDOM_SEED_VALUE, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_RANDOM_SEED_VALUE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRAS, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRAS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_CUSTOM_TRAINING_ADV_WR_PATTERN, AttrMetadataStr(sizeof(ATTR_MSS_CUSTOM_TRAINING_ADV_WR_PATTERN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TWR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TWR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PACKAGE_RANK_MAP, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PACKAGE_RANK_MAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_CTRL_RUN_STOP, AttrMetadataStr(sizeof(ATTR_HTMSC_CTRL_RUN_STOP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RISK_LEVEL, AttrMetadataStr(sizeof(ATTR_RISK_LEVEL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_RBT, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_RBT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_SPD_REVISION, AttrMetadataStr(sizeof(ATTR_MEM_EFF_SPD_REVISION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYS_VFRT_STATIC_DATA_ENABLE, AttrMetadataStr(sizeof(ATTR_SYS_VFRT_STATIC_DATA_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_TEST_NULL_STRING, AttrMetadataStr(sizeof(ATTR_TEST_NULL_STRING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RNG_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_RNG_BASE_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HWAS_STATE, AttrMetadataStr(sizeof(ATTR_HWAS_STATE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TRCD, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TRCD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FAPI_I2C_CONTROL_INFO, AttrMetadataStr(sizeof(ATTR_FAPI_I2C_CONTROL_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_ODT_RD, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_ODT_RD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F30BC2x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F30BC2x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CME_STOP_PHANTOM_HALT_ENABLE, AttrMetadataStr(sizeof(ATTR_CME_STOP_PHANTOM_HALT_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TWTRMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TWTRMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_SAFEMODE_MEM_THROTTLED_N_COMMANDS_PER_PORT, AttrMetadataStr(sizeof(ATTR_EXP_SAFEMODE_MEM_THROTTLED_N_COMMANDS_PER_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_P8EX_L3_COL_REPAIRS, AttrMetadataStr(sizeof(ATTR_MNFG_TH_P8EX_L3_COL_REPAIRS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_EXTREME_THOTTLE_ENABLE, AttrMetadataStr(sizeof(ATTR_VDM_EXTREME_THOTTLE_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_SAMPLE_125US, AttrMetadataStr(sizeof(ATTR_WOV_SAMPLE_125US_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_FMAX_OVERRIDE_KHZ, AttrMetadataStr(sizeof(ATTR_VDM_FMAX_OVERRIDE_KHZ_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_ODIC, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_ODIC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_EXT_VDD_BIAS_TURBO, AttrMetadataStr(sizeof(ATTR_VOLTAGE_EXT_VDD_BIAS_TURBO_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT64_ARRAY_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT64_ARRAY_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_BANK_BITS, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_BANK_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_DRV_IMP_CNTL_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_DRV_IMP_CNTL_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IS_MPIPL_SUPPORTED, AttrMetadataStr(sizeof(ATTR_IS_MPIPL_SUPPORTED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MHZ_PER_WATT, AttrMetadataStr(sizeof(ATTR_PROC_MHZ_PER_WATT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_POWER_SLOPE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_POWER_SLOPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DRAM_CWL, AttrMetadataStr(sizeof(ATTR_MEM_DRAM_CWL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_LPASR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_LPASR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_DDR4_VDDR_SLOPE, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_ECID, AttrMetadataStr(sizeof(ATTR_ECID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_CHIP, AttrMetadataStr(sizeof(ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_CHIP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PCIE_64BIT_MMIO_SIZE, AttrMetadataStr(sizeof(ATTR_PCIE_64BIT_MMIO_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HUGE_PAGE_COUNT, AttrMetadataStr(sizeof(ATTR_HUGE_PAGE_COUNT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_RUNTIME_MEM_M_DRAM_CLOCKS, AttrMetadataStr(sizeof(ATTR_MSS_RUNTIME_MEM_M_DRAM_CLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_PARAM_VALID, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_PARAM_VALID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWA_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWA_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ROW_REPAIR_SPPR_SUPPORTED, AttrMetadataStr(sizeof(ATTR_ROW_REPAIR_SPPR_SUPPORTED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC04, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC04_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT8_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT8_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IVRM_STRENGTH_LOOKUP, AttrMetadataStr(sizeof(ATTR_IVRM_STRENGTH_LOOKUP_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_MEM_THROTTLE_DENOMINATOR, AttrMetadataStr(sizeof(ATTR_MRW_MEM_THROTTLE_DENOMINATOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_LIMIT_ALGORITHM, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_LIMIT_ALGORITHM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_SMF_BAR_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_PROC_SMF_BAR_BASE_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPMI_INSTANCE, AttrMetadataStr(sizeof(ATTR_IPMI_INSTANCE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WAIT_N0, AttrMetadataStr(sizeof(ATTR_WAIT_N0_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_WRITE_DBI, AttrMetadataStr(sizeof(ATTR_CEN_EFF_WRITE_DBI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MASTER_CORE, AttrMetadataStr(sizeof(ATTR_MASTER_CORE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDD_ID, AttrMetadataStr(sizeof(ATTR_VDD_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_TM1_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_TM1_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PIB_I2C_NEST_PLL, AttrMetadataStr(sizeof(ATTR_PIB_I2C_NEST_PLL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BOOT_FREQ_MULT, AttrMetadataStr(sizeof(ATTR_BOOT_FREQ_MULT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F0RC7X, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F0RC7X_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DERIVED_MBA_CACHELINE_INTERLEAVE_MODE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DERIVED_MBA_CACHELINE_INTERLEAVE_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F1BCFx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F1BCFx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_RD_PREAMBLE, AttrMetadataStr(sizeof(ATTR_EFF_RD_PREAMBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F2BCEx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F2BCEx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BMC_SW_TYPE, AttrMetadataStr(sizeof(ATTR_BMC_SW_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TWTR_S, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TWTR_S_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TRFC4MIN_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TRFC4MIN_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FAPI_POS, AttrMetadataStr(sizeof(ATTR_FAPI_POS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_9x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_9x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_NOMINAL_VOLTAGE, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_NOMINAL_VOLTAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OBUS_PAT_A_DETECT_RX_AMP_VALUE, AttrMetadataStr(sizeof(ATTR_IO_OBUS_PAT_A_DETECT_RX_AMP_VALUE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SCHMOO_MULTIPLE_SETUP_CALL, AttrMetadataStr(sizeof(ATTR_CEN_SCHMOO_MULTIPLE_SETUP_CALL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC02, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC02_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_DRAM_STEPPING_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_DRAM_STEPPING_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWA_VOLTAGE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWA_VOLTAGE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PAYLOAD_KIND, AttrMetadataStr(sizeof(ATTR_PAYLOAD_KIND_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FSP_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_FSP_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_RTT_WR, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_RTT_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_HYBRID_MEMORY_TYPE, AttrMetadataStr(sizeof(ATTR_EFF_HYBRID_MEMORY_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPP_ID, AttrMetadataStr(sizeof(ATTR_VPP_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWB_VOLTAGE_RANGE_SELECT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWB_VOLTAGE_RANGE_SELECT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_A_AGGREGATE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_A_AGGREGATE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CME_CHTM_TRACE_ENABLE, AttrMetadataStr(sizeof(ATTR_CME_CHTM_TRACE_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_ROT_RST_FW, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_ROT_RST_FW_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTM_QUEUES, AttrMetadataStr(sizeof(ATTR_HTM_QUEUES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PSI_HB_ESB_ADDR, AttrMetadataStr(sizeof(ATTR_PSI_HB_ESB_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_TYPE, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F4BC6x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F4BC6x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ADC_CHANNEL_GAINS, AttrMetadataStr(sizeof(ATTR_ADC_CHANNEL_GAINS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWC_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWC_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NHTM_BAR_SIZE, AttrMetadataStr(sizeof(ATTR_PROC_NHTM_BAR_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F30BC5x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F30BC5x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DRAM_RTT_NOM, AttrMetadataStr(sizeof(ATTR_MEM_SI_DRAM_RTT_NOM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_TX_MARGIN_RATIO, AttrMetadataStr(sizeof(ATTR_IO_OMI_TX_MARGIN_RATIO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_REC_NUM, AttrMetadataStr(sizeof(ATTR_VPD_REC_NUM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_IC_BAR_PAGE_SIZE, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_IC_BAR_PAGE_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_INT_CQ_PC_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_INT_CQ_PC_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_WIDTH, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_WIDTH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_MC_DRV_IMP_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_MC_DRV_IMP_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CALCULATED_PROC_MEMORY_POWER_DROP, AttrMetadataStr(sizeof(ATTR_CALCULATED_PROC_MEMORY_POWER_DROP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_DEBUG, AttrMetadataStr(sizeof(ATTR_IO_OMI_DEBUG_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MC_PLL_BUCKET, AttrMetadataStr(sizeof(ATTR_MC_PLL_BUCKET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_TMPL_0_PACING, AttrMetadataStr(sizeof(ATTR_PROC_TMPL_0_PACING_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_CORE_FLOOR_RATIO, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_CORE_FLOOR_RATIO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SECONDARY_RANK_GROUP1, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SECONDARY_RANK_GROUP1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC05, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC05_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_VRM_VOFFSET_VCS_UV, AttrMetadataStr(sizeof(ATTR_PROC_VRM_VOFFSET_VCS_UV_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_VPD_DQ_MAP, AttrMetadataStr(sizeof(ATTR_MEM_VPD_DQ_MAP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_BUFFER_LATENCY, AttrMetadataStr(sizeof(ATTR_EFF_BUFFER_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_PCIE_IOP_REVERSAL_NON_BIFURCATED, AttrMetadataStr(sizeof(ATTR_PEC_PCIE_IOP_REVERSAL_NON_BIFURCATED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_MAX_POWERDOWN_MODE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_MAX_POWERDOWN_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SUPPORTED_STOP_STATES, AttrMetadataStr(sizeof(ATTR_SUPPORTED_STOP_STATES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_CHTM_BAR_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_PROC_CHTM_BAR_BASE_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FSP_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_FSP_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT16_ARRAY_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT16_ARRAY_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_GPU_MEM_ERROR_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_GPU_MEM_ERROR_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CLEAR_DIMM_SPD_ENABLE, AttrMetadataStr(sizeof(ATTR_CLEAR_DIMM_SPD_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_MBA_CACHELINE_INTERLEAVE_MODE_CONTROL, AttrMetadataStr(sizeof(ATTR_CEN_MRW_MBA_CACHELINE_INTERLEAVE_MODE_CONTROL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_DATA_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_DATA_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_DDR4_VDDR_MAX_LIMIT_POST_DRAM_INIT, AttrMetadataStr(sizeof(ATTR_MRW_DDR4_VDDR_MAX_LIMIT_POST_DRAM_INIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_RSV_MEM_NUM_SECTIONS, AttrMetadataStr(sizeof(ATTR_HDAT_RSV_MEM_NUM_SECTIONS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_TOTAL_PWR_INTERCEPT, AttrMetadataStr(sizeof(ATTR_EXP_TOTAL_PWR_INTERCEPT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VCS_AVSBUS_BUSNUM, AttrMetadataStr(sizeof(ATTR_VCS_AVSBUS_BUSNUM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NOMINAL_FREQ_MHZ, AttrMetadataStr(sizeof(ATTR_NOMINAL_FREQ_MHZ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_OVERV_MAX_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_OVERV_MAX_10THPCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_DDR4_VDDR_MAX_LIMIT, AttrMetadataStr(sizeof(ATTR_CEN_MRW_DDR4_VDDR_MAX_LIMIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TAAMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TAAMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F0BC6x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F0BC6x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_4x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_4x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC0A, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC0A_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWB_VOLTAGE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWB_VOLTAGE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TXS, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TXS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_MCS_PER_SYSTEM, AttrMetadataStr(sizeof(ATTR_MAX_MCS_PER_SYSTEM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PCI_REFCLOCK_RCVR_TERM, AttrMetadataStr(sizeof(ATTR_PCI_REFCLOCK_RCVR_TERM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_PORT_MAXPOWER, AttrMetadataStr(sizeof(ATTR_MSS_PORT_MAXPOWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F0RC1X, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F0RC1X_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EX_INSIDE_SPECIAL_WAKEUP, AttrMetadataStr(sizeof(ATTR_EX_INSIDE_SPECIAL_WAKEUP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EFF_VPD_VERSION, AttrMetadataStr(sizeof(ATTR_MSS_EFF_VPD_VERSION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CORE_INSIDE_SPECIAL_WAKEUP, AttrMetadataStr(sizeof(ATTR_CORE_INSIDE_SPECIAL_WAKEUP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VCCD_OVERRIDE, AttrMetadataStr(sizeof(ATTR_MSS_VCCD_OVERRIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CORE_THROTTLE_DEASSERT_COUNT, AttrMetadataStr(sizeof(ATTR_CORE_THROTTLE_DEASSERT_COUNT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_MIRROR_PLACEMENT_POLICY, AttrMetadataStr(sizeof(ATTR_MEM_MIRROR_PLACEMENT_POLICY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_A_ADDR_DIS, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_A_ADDR_DIS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_DCM_INSTALLED, AttrMetadataStr(sizeof(ATTR_PROC_DCM_INSTALLED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_PRIMARY_RANK_GROUP0, AttrMetadataStr(sizeof(ATTR_CEN_EFF_PRIMARY_RANK_GROUP0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_MBA, AttrMetadataStr(sizeof(ATTR_CEN_MSS_MEM_THROTTLE_NUMERATOR_PER_MBA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_VGA_CNTL_REG2, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_VGA_CNTL_REG2_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_DIMM_RCD_IBT_ODT, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_DIMM_RCD_IBT_ODT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT64_ARRAY_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT64_ARRAY_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_DLL_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_DLL_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_STOP_ON_ERROR, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_STOP_ON_ERROR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SECONDARY_RANK_GROUP3, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SECONDARY_RANK_GROUP3_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OMI_REFCLOCK_SWIZZLE, AttrMetadataStr(sizeof(ATTR_OMI_REFCLOCK_SWIZZLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_L2_CACHE_ASSOC_SETS, AttrMetadataStr(sizeof(ATTR_L2_CACHE_ASSOC_SETS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRRD_DLR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRRD_DLR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TEST_NO_DEFAULT_STRING, AttrMetadataStr(sizeof(ATTR_TEST_NO_DEFAULT_STRING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_EC, AttrMetadataStr(sizeof(ATTR_HDAT_EC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_PSRO, AttrMetadataStr(sizeof(ATTR_CEN_MSS_PSRO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SELF_REF_ABORT, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SELF_REF_ABORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TMAW, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TMAW_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_REFCLOCK_RCVR_TERM, AttrMetadataStr(sizeof(ATTR_PROC_REFCLOCK_RCVR_TERM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NVDIMM_AUTO_ARM, AttrMetadataStr(sizeof(ATTR_NVDIMM_AUTO_ARM_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC0D, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC0D_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_DDR4_VDDR_MAX_LIMIT, AttrMetadataStr(sizeof(ATTR_MRW_DDR4_VDDR_MAX_LIMIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_BRANCH_PIBMEM_ADDR, AttrMetadataStr(sizeof(ATTR_BRANCH_PIBMEM_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_ODIC, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_ODIC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PHYS_PRES_REIPL, AttrMetadataStr(sizeof(ATTR_PHYS_PRES_REIPL_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VDD_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VDD_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FTB_DIVISOR, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FTB_DIVISOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DRAM_DRV_IMP_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MEM_SI_DRAM_DRV_IMP_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PB_BNDY_DMIPLL_DATA, AttrMetadataStr(sizeof(ATTR_PROC_PB_BNDY_DMIPLL_DATA_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_TOTAL_PWR_SLOPE, AttrMetadataStr(sizeof(ATTR_EXP_TOTAL_PWR_SLOPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_GEARDOWN_MODE, AttrMetadataStr(sizeof(ATTR_MEM_SI_GEARDOWN_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC0C, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC0C_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_XSCOM_BASE_ADDRESS, AttrMetadataStr(sizeof(ATTR_XSCOM_BASE_ADDRESS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_CRC_BASE_CONFIG_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_CRC_BASE_CONFIG_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MVPD_FWMS, AttrMetadataStr(sizeof(ATTR_MSS_MVPD_FWMS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_PER_DRAM_ACCESS, AttrMetadataStr(sizeof(ATTR_EFF_PER_DRAM_ACCESS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_DMI_MIN_EYE_WIDTH, AttrMetadataStr(sizeof(ATTR_MNFG_DMI_MIN_EYE_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_RAND, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_RAND_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_RUNTIME_MEM_M_DRAM_CLOCKS, AttrMetadataStr(sizeof(ATTR_EXP_RUNTIME_MEM_M_DRAM_CLOCKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEMD_OFFSET, AttrMetadataStr(sizeof(ATTR_MEMD_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_ACTAG_BASE, AttrMetadataStr(sizeof(ATTR_EXPLR_ACTAG_BASE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_FORCE_BCMODE_OFF, AttrMetadataStr(sizeof(ATTR_MSS_MRW_FORCE_BCMODE_OFF_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_LPC_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_LPC_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VPP_SLOPE, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VPP_SLOPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_DIMM_POWER_CURVE_PERCENT_UPLIFT_IDLE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_DIMM_POWER_CURVE_PERCENT_UPLIFT_IDLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MMIO_VM_ADDR, AttrMetadataStr(sizeof(ATTR_MMIO_VM_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_BANKS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_BANKS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SECONDARY_RANK_GROUP2, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SECONDARY_RANK_GROUP2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FABRIC_TO_PHYSICAL_NODE_MAP, AttrMetadataStr(sizeof(ATTR_FABRIC_TO_PHYSICAL_NODE_MAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_0_VERSION_LAYOUT, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_0_VERSION_LAYOUT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_INT_VDD_BIAS_POWERSAVE, AttrMetadataStr(sizeof(ATTR_VOLTAGE_INT_VDD_BIAS_POWERSAVE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FSP_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_FSP_BASE_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_REGISTER_TYPE, AttrMetadataStr(sizeof(ATTR_EFF_REGISTER_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_CAL_STEP_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_CAL_STEP_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHTM_CTRL_MARK, AttrMetadataStr(sizeof(ATTR_CHTM_CTRL_MARK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_1x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_1x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_SLEW_RATE_CLK, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_SLEW_RATE_CLK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_FREQ_OVERRIDE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_FREQ_OVERRIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT8_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT8_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWC_VOLTAGE_RANGE_SELECT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWC_VOLTAGE_RANGE_SELECT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_LINK_ACTIVE, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_LINK_ACTIVE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EEPROM_NV_INFO, AttrMetadataStr(sizeof(ATTR_EEPROM_NV_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_PERIODIC_ZQCAL_MODE_OPTIONS, AttrMetadataStr(sizeof(ATTR_MSS_MRW_PERIODIC_ZQCAL_MODE_OPTIONS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRP, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_CORE_CEILING_MHZ, AttrMetadataStr(sizeof(ATTR_FREQ_CORE_CEILING_MHZ_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_RD_PREAMBLE_TRAIN, AttrMetadataStr(sizeof(ATTR_CEN_EFF_RD_PREAMBLE_TRAIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHIP_VER, AttrMetadataStr(sizeof(ATTR_CHIP_VER_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPAL_MODEL, AttrMetadataStr(sizeof(ATTR_OPAL_MODEL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SW_VER, AttrMetadataStr(sizeof(ATTR_SW_VER_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_Ax, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_Ax_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_BUS_FREQ, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_BUS_FREQ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EFF_DIMM_FUNCTIONAL_VECTOR, AttrMetadataStr(sizeof(ATTR_MSS_EFF_DIMM_FUNCTIONAL_VECTOR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_DDR3_VDDR_MAX_LIMIT, AttrMetadataStr(sizeof(ATTR_CEN_MRW_DDR3_VDDR_MAX_LIMIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EPS_READ_CYCLES_T1, AttrMetadataStr(sizeof(ATTR_PROC_EPS_READ_CYCLES_T1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC03, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC03_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_CHANNEL_PAIR_MAXPOWER, AttrMetadataStr(sizeof(ATTR_CEN_MSS_CHANNEL_PAIR_MAXPOWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SOCKET_POWER_TURBO, AttrMetadataStr(sizeof(ATTR_SOCKET_POWER_TURBO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT16_ARRAY_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT16_ARRAY_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_DQ_TO_DIMM_CONN_DQ, AttrMetadataStr(sizeof(ATTR_CEN_DQ_TO_DIMM_CONN_DQ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IVRM_STABILIZATION_DELAY_NS, AttrMetadataStr(sizeof(ATTR_IVRM_STABILIZATION_DELAY_NS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_MEMCAL_INTERVAL, AttrMetadataStr(sizeof(ATTR_CEN_EFF_MEMCAL_INTERVAL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TOD_ROLE, AttrMetadataStr(sizeof(ATTR_TOD_ROLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MEM_BASES_ACK, AttrMetadataStr(sizeof(ATTR_PROC_MEM_BASES_ACK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_MAX_DROOP_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_MAX_DROOP_10THPCT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MBA_PORT, AttrMetadataStr(sizeof(ATTR_CEN_MBA_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FSI_OPTION_FLAGS, AttrMetadataStr(sizeof(ATTR_FSI_OPTION_FLAGS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_IS_STARTED, AttrMetadataStr(sizeof(ATTR_SBE_IS_STARTED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_4x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_4x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_WR_LVL_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_WR_LVL_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_CORE_PERIODIC_QUIESCE_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_CORE_PERIODIC_QUIESCE_DISABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC11, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC11_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_CDIMM_MASTER_I2C_TEMP_SENSOR_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_MRW_CDIMM_MASTER_I2C_TEMP_SENSOR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_MIN_MEM_UTILIZATION_THROTTLING, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_MIN_MEM_UTILIZATION_THROTTLING_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CLOCK_PLL_MUX_TOD, AttrMetadataStr(sizeof(ATTR_CLOCK_PLL_MUX_TOD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_PM_MODE, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_PM_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_SLEW_RATE_ADR, AttrMetadataStr(sizeof(ATTR_MSS_SLEW_RATE_ADR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CP_REFCLOCK_RCVR_TERM, AttrMetadataStr(sizeof(ATTR_CP_REFCLOCK_RCVR_TERM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_PACKAGE_RANK_MAP, AttrMetadataStr(sizeof(ATTR_EFF_PACKAGE_RANK_MAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRFC, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRFC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_CK_ENABLE, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_CK_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TPM_INFO, AttrMetadataStr(sizeof(ATTR_TPM_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NDL_MESHCTRL_SETUP, AttrMetadataStr(sizeof(ATTR_NDL_MESHCTRL_SETUP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_GEARDOWN_MODE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_GEARDOWN_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_HALF_DIMM_MODE_OVERRIDE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_HALF_DIMM_MODE_OVERRIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_N_BULK_POWER_LIMIT_WATTS, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_N_BULK_POWER_LIMIT_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TDQS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TDQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_QUAD_WEIGHT, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_QUAD_WEIGHT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_CA_PARITY_LATENCY, AttrMetadataStr(sizeof(ATTR_EFF_CA_PARITY_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_OVERVOLT_OVERRIDE, AttrMetadataStr(sizeof(ATTR_VDM_OVERVOLT_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_SOFT_PPR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_SOFT_PPR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_HTMSC_MODE_WRITETOIO, AttrMetadataStr(sizeof(ATTR_NHTM_HTMSC_MODE_WRITETOIO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRTP, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRTP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_RESCLK_DISABLE, AttrMetadataStr(sizeof(ATTR_SYSTEM_RESCLK_DISABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NX_RNG_FAILED_INT_ADDR, AttrMetadataStr(sizeof(ATTR_PROC_NX_RNG_FAILED_INT_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_DLL_RESET, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_DLL_RESET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ERROR_CAPTURE, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ERROR_CAPTURE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_TOTAL_POWER_SLOPE2, AttrMetadataStr(sizeof(ATTR_CEN_MSS_TOTAL_POWER_SLOPE2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_LEAKAGE_PERCENT, AttrMetadataStr(sizeof(ATTR_NEST_LEAKAGE_PERCENT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_L3_HASPOWER, AttrMetadataStr(sizeof(ATTR_L3_HASPOWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_5x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_5x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DPLL_VDM_RESPONSE, AttrMetadataStr(sizeof(ATTR_DPLL_VDM_RESPONSE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FORCE_SRAM_MMIO_OVER_I2C, AttrMetadataStr(sizeof(ATTR_FORCE_SRAM_MMIO_OVER_I2C_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT16_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT16_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CRC_ERROR_CLEAR, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CRC_ERROR_CLEAR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_PB_MHZ_POUNDV_FALLBACK, AttrMetadataStr(sizeof(ATTR_FREQ_PB_MHZ_POUNDV_FALLBACK_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A08, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A08_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FINE_OFFSET_TCKMAX_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FINE_OFFSET_TCKMAX_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_READ_DBI, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_READ_DBI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_BMC_FRU_ID, AttrMetadataStr(sizeof(ATTR_BMC_FRU_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHTM_HTMSC_MODE_CONTENT_SEL, AttrMetadataStr(sizeof(ATTR_CHTM_HTMSC_MODE_CONTENT_SEL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_TEMP_READOUT, AttrMetadataStr(sizeof(ATTR_EFF_TEMP_READOUT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_REGISTER_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_REGISTER_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_WR, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_VRM_VDD_DVFS_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_VRM_VDD_DVFS_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_SMF_BAR_SIZE, AttrMetadataStr(sizeof(ATTR_PROC_SMF_BAR_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FSI_MASTER_PORT, AttrMetadataStr(sizeof(ATTR_FSI_MASTER_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_A_MHZ, AttrMetadataStr(sizeof(ATTR_FREQ_A_MHZ_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PG, AttrMetadataStr(sizeof(ATTR_PG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OMI_MFG_STRESS_PR_OFFSET_ODD, AttrMetadataStr(sizeof(ATTR_IO_OMI_MFG_STRESS_PR_OFFSET_ODD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CKE0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_BANK_GROUP_BITS, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_BANK_GROUP_BITS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IPS_ENTER_UTILIZATION_PERCENT, AttrMetadataStr(sizeof(ATTR_IPS_ENTER_UTILIZATION_PERCENT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_IGNORE_PLUG_RULES, AttrMetadataStr(sizeof(ATTR_MEM_IGNORE_PLUG_RULES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CDM_POLICIES, AttrMetadataStr(sizeof(ATTR_CDM_POLICIES_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SBE_UPDATE_DISABLE, AttrMetadataStr(sizeof(ATTR_SBE_UPDATE_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_MBA_PORTS_PER_MBA, AttrMetadataStr(sizeof(ATTR_MAX_MBA_PORTS_PER_MBA_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_MAX_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_MAX_10THPCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_ROWS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_ROWS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_DATABUS_UTIL_PER_MBA, AttrMetadataStr(sizeof(ATTR_MSS_DATABUS_UTIL_PER_MBA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MIRROR_BASES, AttrMetadataStr(sizeof(ATTR_PROC_MIRROR_BASES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC_2x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC_2x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_APSS_GPIO_PORT_MODES, AttrMetadataStr(sizeof(ATTR_APSS_GPIO_PORT_MODES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_RISK_LEVEL_ORIGIN, AttrMetadataStr(sizeof(ATTR_RISK_LEVEL_ORIGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_DIFF_AVAIL, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_DIFF_AVAIL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_MFG_ID, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_MFG_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_0_USAGE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_0_USAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWD_VOLTAGE_RANGE_SELECT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWD_VOLTAGE_RANGE_SELECT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A17, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A17_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_ODT1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_I2C_DEV_TYPE, AttrMetadataStr(sizeof(ATTR_I2C_DEV_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_DLL_ENABLE, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_DLL_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_TTYPEFILT_PAT, AttrMetadataStr(sizeof(ATTR_HTMSC_TTYPEFILT_PAT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_MW_ENABLE, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_MW_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_START_PIBMEM_ADDR, AttrMetadataStr(sizeof(ATTR_START_PIBMEM_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_INITIATED_PM_RESET, AttrMetadataStr(sizeof(ATTR_INITIATED_PM_RESET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_WR_VREF_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_WR_VREF_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC_2x, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC_2x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OVERRIDE_MEMDIAGS_BCMODE, AttrMetadataStr(sizeof(ATTR_MSS_OVERRIDE_MEMDIAGS_BCMODE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ENABLE_MEM_EARLY_DATA_SCOM, AttrMetadataStr(sizeof(ATTR_ENABLE_MEM_EARLY_DATA_SCOM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_GPIO_INFO, AttrMetadataStr(sizeof(ATTR_GPIO_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_MEM_M_DRAM_CLOCKS, AttrMetadataStr(sizeof(ATTR_MSS_MRW_MEM_M_DRAM_CLOCKS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_REFRESH_RATE_REQUEST, AttrMetadataStr(sizeof(ATTR_MSS_MRW_REFRESH_RATE_REQUEST_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_FTB_DIVIDEND, AttrMetadataStr(sizeof(ATTR_CEN_SPD_FTB_DIVIDEND_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DRAM_GEN_METADATA, AttrMetadataStr(sizeof(ATTR_MEM_DRAM_GEN_METADATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_HSL_OPTICONNECT_CONNECTIONS, AttrMetadataStr(sizeof(ATTR_MAX_HSL_OPTICONNECT_CONNECTIONS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_MPR_PAGE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_MPR_PAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A00, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_A00_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_VMEM_REGULATOR_MEMORY_POWER_LIMIT_PER_DIMM_DDR3, AttrMetadataStr(sizeof(ATTR_MRW_VMEM_REGULATOR_MEMORY_POWER_LIMIT_PER_DIMM_DDR3_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_TMPL_4_PACING, AttrMetadataStr(sizeof(ATTR_PROC_TMPL_4_PACING_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_BACKUP_SEEPROM_SELECT, AttrMetadataStr(sizeof(ATTR_BACKUP_SEEPROM_SELECT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_LRDIMM_RANK_MULT_MODE, AttrMetadataStr(sizeof(ATTR_CEN_LRDIMM_RANK_MULT_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PIBMEM_REPAIR0, AttrMetadataStr(sizeof(ATTR_PIBMEM_REPAIR0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RECONFIG_LOOP_TESTS_ENABLE, AttrMetadataStr(sizeof(ATTR_RECONFIG_LOOP_TESTS_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_TTYPEFILT_INVERT, AttrMetadataStr(sizeof(ATTR_HTMSC_TTYPEFILT_INVERT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_HYBRID_MEMORY_TYPE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_HYBRID_MEMORY_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_INT_VDD_BIAS_NOMINAL, AttrMetadataStr(sizeof(ATTR_VOLTAGE_INT_VDD_BIAS_NOMINAL_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_I2C_BUS_SPEED_ARRAY, AttrMetadataStr(sizeof(ATTR_I2C_BUS_SPEED_ARRAY_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EPS_WRITE_CYCLES_T2, AttrMetadataStr(sizeof(ATTR_PROC_EPS_WRITE_CYCLES_T2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F30BCBx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F30BCBx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_TERTIARY_RANK_GROUP1, AttrMetadataStr(sizeof(ATTR_CEN_EFF_TERTIARY_RANK_GROUP1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MRW_POWER_CONTROL_REQUESTED, AttrMetadataStr(sizeof(ATTR_CEN_MRW_POWER_CONTROL_REQUESTED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BG1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_O_MFG_STRESS_PR_OFFSET_EVEN, AttrMetadataStr(sizeof(ATTR_IO_O_MFG_STRESS_PR_OFFSET_EVEN_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_MEMORY_BUS_WIDTH, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_MEMORY_BUS_WIDTH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FABRIC_CHIP_ID, AttrMetadataStr(sizeof(ATTR_FABRIC_CHIP_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F1RC05, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F1RC05_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_DENSITY, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_DENSITY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_A_ATTACHED_LINK_ID, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_A_ATTACHED_LINK_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_TX_FIFO_CONFIG_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_TX_FIFO_CONFIG_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_CHTM_BAR_SIZES, AttrMetadataStr(sizeof(ATTR_PROC_CHTM_BAR_SIZES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_CS_CMD_LATENCY, AttrMetadataStr(sizeof(ATTR_MEM_CS_CMD_LATENCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F5BC3x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F5BC3x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FORCE_NVDIMM_RESET, AttrMetadataStr(sizeof(ATTR_FORCE_NVDIMM_RESET_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TPM_POISONED, AttrMetadataStr(sizeof(ATTR_TPM_POISONED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_IMP_CLK, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_IMP_CLK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VPP_SLOPE_POST_DRAM_INIT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VPP_SLOPE_POST_DRAM_INIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PIBMEM_REPAIR2, AttrMetadataStr(sizeof(ATTR_PIBMEM_REPAIR2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_REL_POS, AttrMetadataStr(sizeof(ATTR_REL_POS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_I2C_BUS_DIV_NEST, AttrMetadataStr(sizeof(ATTR_I2C_BUS_DIV_NEST_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_1_TYPE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_1_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_1_AVAIL, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_1_AVAIL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_MEM_REFCLOCK, AttrMetadataStr(sizeof(ATTR_FREQ_MEM_REFCLOCK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_LMB_SIZE, AttrMetadataStr(sizeof(ATTR_LMB_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_TTYPEFILT_MASK, AttrMetadataStr(sizeof(ATTR_HTMSC_TTYPEFILT_MASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_TX_PCIE_RECV_DETECT_CNTL_REG1, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_TX_PCIE_RECV_DETECT_CNTL_REG1_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_ODT_INPUT_BUFF, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_ODT_INPUT_BUFF_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_MODULE_BUS_WIDTH, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_MODULE_BUS_WIDTH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EFF_FABRIC_CHIP_ID, AttrMetadataStr(sizeof(ATTR_PROC_EFF_FABRIC_CHIP_ID_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_VRM_READ_TIMEOUT_SEC, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_VRM_READ_TIMEOUT_SEC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_DFIMRL_CLK, AttrMetadataStr(sizeof(ATTR_MEM_EXP_DFIMRL_CLK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_PERIODIC_MEMCAL_MODE_OPTIONS, AttrMetadataStr(sizeof(ATTR_MSS_MRW_PERIODIC_MEMCAL_MODE_OPTIONS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_POST_MEMDIAGS_READ_SUBTEST, AttrMetadataStr(sizeof(ATTR_MSS_POST_MEMDIAGS_READ_SUBTEST_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_SIZE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_DRAM_ADDRESS_MIRRORING, AttrMetadataStr(sizeof(ATTR_MEM_EXP_DRAM_ADDRESS_MIRRORING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_INT8_ARRAY_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_INT8_ARRAY_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_APSS_GPIO_PORT_PINS, AttrMetadataStr(sizeof(ATTR_APSS_GPIO_PORT_PINS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_AVDD_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MEM_AVDD_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWB_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWB_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_OVERRIDE, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_OVERRIDE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_TMPL_5_PACING, AttrMetadataStr(sizeof(ATTR_EXPLR_TMPL_5_PACING_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_START_SEEPROM_ADDR, AttrMetadataStr(sizeof(ATTR_START_SEEPROM_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWB_VOLTAGE_RANGE_SELECT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWB_VOLTAGE_RANGE_SELECT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_DLL_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_DLL_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_X_EREPAIR_THRESHOLD_FIELD, AttrMetadataStr(sizeof(ATTR_X_EREPAIR_THRESHOLD_FIELD_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_LOCATION, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_ID_MODULE_MANUFACTURING_LOCATION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN0, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D1_CSN0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NVDIMM_ARMED, AttrMetadataStr(sizeof(ATTR_NVDIMM_ARMED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_RD_PREAMBLE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_RD_PREAMBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_SPIPSS_CLOCK_DIVIDER, AttrMetadataStr(sizeof(ATTR_PM_SPIPSS_CLOCK_DIVIDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NVDIMM_UPDATE_I2C_BLOCK_SIZE, AttrMetadataStr(sizeof(ATTR_NVDIMM_UPDATE_I2C_BLOCK_SIZE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_POWERCAP_MEM_POWER, AttrMetadataStr(sizeof(ATTR_POWERCAP_MEM_POWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IVRM_ENABLED, AttrMetadataStr(sizeof(ATTR_IVRM_ENABLED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TCCD_L, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TCCD_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MEM_SIZES, AttrMetadataStr(sizeof(ATTR_PROC_MEM_SIZES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_PRIMARY_RANK_GROUP3, AttrMetadataStr(sizeof(ATTR_CEN_EFF_PRIMARY_RANK_GROUP3_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_PASR, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_PASR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_PSTATES_MODE, AttrMetadataStr(sizeof(ATTR_SYSTEM_PSTATES_MODE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MFG_WRAP_TEST_ABUS_LINKS_SET, AttrMetadataStr(sizeof(ATTR_MFG_WRAP_TEST_ABUS_LINKS_SET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_DRAM_RTT_PARK, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_DRAM_RTT_PARK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_DRAM_RTT_PARK, AttrMetadataStr(sizeof(ATTR_MEM_SI_DRAM_RTT_PARK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_PORT, AttrMetadataStr(sizeof(ATTR_MEM_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWA_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWA_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VCS_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VCS_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_DMI_REFCLOCK_RCVR_TERM, AttrMetadataStr(sizeof(ATTR_CEN_DMI_REFCLOCK_RCVR_TERM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_IMP_CSCID, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_IMP_CSCID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_MAX_POWERDOWN_MODE, AttrMetadataStr(sizeof(ATTR_CEN_EFF_MAX_POWERDOWN_MODE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OMI_DL_PREIPL_PRBS_TIME, AttrMetadataStr(sizeof(ATTR_OMI_DL_PREIPL_PRBS_TIME_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_TEST_VALID, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_TEST_VALID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_MAC, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_MAC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_FILT_CRESP_PAT, AttrMetadataStr(sizeof(ATTR_HTMSC_FILT_CRESP_PAT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ENABLED_THREADS, AttrMetadataStr(sizeof(ATTR_ENABLED_THREADS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DDR3_VDDR_SLOPE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DDR3_VDDR_SLOPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_BA1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ALL_MCS_IN_INTERLEAVING_GROUP, AttrMetadataStr(sizeof(ATTR_ALL_MCS_IN_INTERLEAVING_GROUP_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_MRAM_SUPPORT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_MRAM_SUPPORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F6BC3x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F6BC3x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYS_FORCE_ALL_CORES, AttrMetadataStr(sizeof(ATTR_SYS_FORCE_ALL_CORES_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TCKMAX_DDR4, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TCKMAX_DDR4_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_ADDR, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_ADDR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VLAN_SWITCHES, AttrMetadataStr(sizeof(ATTR_VLAN_SWITCHES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_3DS_HEIGHT, AttrMetadataStr(sizeof(ATTR_MEM_3DS_HEIGHT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_DIMM_THERMAL_LIMIT, AttrMetadataStr(sizeof(ATTR_EXP_DIMM_THERMAL_LIMIT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOF_ENABLE_FRATIO, AttrMetadataStr(sizeof(ATTR_WOF_ENABLE_FRATIO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_RCV_IMP_DQ_DQS_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_SRT, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_SRT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_INTERLEAVE_GROUP_SIZE, AttrMetadataStr(sizeof(ATTR_MAX_INTERLEAVE_GROUP_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_VPP_OFFSET_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_MRW_VPP_OFFSET_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HB_SBE_SEEPROM_VERSION_MISMATCH, AttrMetadataStr(sizeof(ATTR_HB_SBE_SEEPROM_VERSION_MISMATCH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VPD_OVERRIDE_DQ_ENABLE, AttrMetadataStr(sizeof(ATTR_VPD_OVERRIDE_DQ_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CHKSTOP_ANALYSIS_ON_STARTUP, AttrMetadataStr(sizeof(ATTR_CHKSTOP_ANALYSIS_ON_STARTUP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_I2C_DEVICE_LABEL, AttrMetadataStr(sizeof(ATTR_HDAT_I2C_DEVICE_LABEL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_RING_DBG_MODE, AttrMetadataStr(sizeof(ATTR_SYSTEM_RING_DBG_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_TRACE_TYPE, AttrMetadataStr(sizeof(ATTR_NHTM_TRACE_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_THERMAL_MEMORY_POWER_LIMIT, AttrMetadataStr(sizeof(ATTR_MSS_MRW_THERMAL_MEMORY_POWER_LIMIT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_SHRT_BACKOFF_TIMER, AttrMetadataStr(sizeof(ATTR_EXPLR_SHRT_BACKOFF_TIMER_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F30BC8x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F30BC8x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_DRV_IMP_CLK_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_DRV_IMP_CLK_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_MEMCTRL_READ_TIMEOUT_SEC, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_MEMCTRL_READ_TIMEOUT_SEC_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOV_UNDERV_STEP_DECR_10THPCT, AttrMetadataStr(sizeof(ATTR_WOV_UNDERV_STEP_DECR_10THPCT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IVRM_VIN_MAX_MV, AttrMetadataStr(sizeof(ATTR_IVRM_VIN_MAX_MV_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_TDQS, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_TDQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_XBUS_TX_FFE_PRECURSOR, AttrMetadataStr(sizeof(ATTR_IO_XBUS_TX_FFE_PRECURSOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_VDD_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_VDD_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_IMP_CMD_ADDR, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_IMP_CMD_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DIMM_RANKS_CONFIGED, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DIMM_RANKS_CONFIGED_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_MPR_PAGE, AttrMetadataStr(sizeof(ATTR_EFF_MPR_PAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_MFG_ID, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_MFG_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_I2C_BUS_DIV_REF, AttrMetadataStr(sizeof(ATTR_I2C_BUS_DIV_REF_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_TX_POWER_SEQ_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_TX_POWER_SEQ_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_SDRAM_DIE_COUNT, AttrMetadataStr(sizeof(ATTR_CEN_SPD_SDRAM_DIE_COUNT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_FREQ_RETURN_S_N_OVERRIDE, AttrMetadataStr(sizeof(ATTR_VDM_FREQ_RETURN_S_N_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_AVDD_ID, AttrMetadataStr(sizeof(ATTR_AVDD_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_UNSUPPORTED_RANK_CONFIG, AttrMetadataStr(sizeof(ATTR_MSS_MRW_UNSUPPORTED_RANK_CONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MASTER_EX, AttrMetadataStr(sizeof(ATTR_MASTER_EX_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_ALLOW_SINGLE_PORT, AttrMetadataStr(sizeof(ATTR_CEN_MSS_ALLOW_SINGLE_PORT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IVRM_STEP_DELAY_NS, AttrMetadataStr(sizeof(ATTR_IVRM_STEP_DELAY_NS_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F1BCEx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F1BCEx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_DIMM_DDR4_F0RC0B, AttrMetadataStr(sizeof(ATTR_MEM_DIMM_DDR4_F0RC0B_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_IGNORE_PLUG_RULES, AttrMetadataStr(sizeof(ATTR_MSS_IGNORE_PLUG_RULES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EPS_READ_CYCLES_T0, AttrMetadataStr(sizeof(ATTR_PROC_EPS_READ_CYCLES_T0_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MFG_TRACE_ENABLE, AttrMetadataStr(sizeof(ATTR_MFG_TRACE_ENABLE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_BOOT_CONFIG_LANE_MODE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_LANE_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TCCD_L, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TCCD_L_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RUN_MAX_MEM_PATTERNS, AttrMetadataStr(sizeof(ATTR_RUN_MAX_MEM_PATTERNS_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PSTATEGPE_BOOT_COPIER_IVPR_OFFSET, AttrMetadataStr(sizeof(ATTR_PSTATEGPE_BOOT_COPIER_IVPR_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_SLEW_RATE_ADR, AttrMetadataStr(sizeof(ATTR_CEN_MSS_SLEW_RATE_ADR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SLOT_NAME, AttrMetadataStr(sizeof(ATTR_SLOT_NAME_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_CHIP, AttrMetadataStr(sizeof(ATTR_MRW_SAFEMODE_MEM_THROTTLE_NUMERATOR_PER_CHIP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_POWER_PATH, AttrMetadataStr(sizeof(ATTR_POWER_PATH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DIMM_SIZE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DIMM_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_RC0C, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_RC0C_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_UTIL_N_PER_MBA, AttrMetadataStr(sizeof(ATTR_MSS_UTIL_N_PER_MBA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_ADDR_CMD_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_TMPL_A_PACING, AttrMetadataStr(sizeof(ATTR_PROC_TMPL_A_PACING_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CLOCK_PLL_MUX, AttrMetadataStr(sizeof(ATTR_CLOCK_PLL_MUX_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC06_07, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC06_07_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_VREF_STEP, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_VREF_STEP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_RD_VREF_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_RD_VREF_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC0D, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC0D_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OCMB_COUNTER_HB, AttrMetadataStr(sizeof(ATTR_OCMB_COUNTER_HB_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HYP_DISPATCH_WHEEL, AttrMetadataStr(sizeof(ATTR_HYP_DISPATCH_WHEEL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_WR_VREF, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_WR_VREF_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_IOP_CONFIG, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_IOP_CONFIG_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_DIMM_SPD_BYTE_SIZE, AttrMetadataStr(sizeof(ATTR_DIMM_SPD_BYTE_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC09, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC09_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_MC_DRV_SLEW_RATE_CMD_ADDR, AttrMetadataStr(sizeof(ATTR_MEM_SI_MC_DRV_SLEW_RATE_CMD_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_BIAS_ULTRATURBO, AttrMetadataStr(sizeof(ATTR_FREQ_BIAS_ULTRATURBO_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_2N_MODE_AUTOSET, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_2N_MODE_AUTOSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT32_ARRAY_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT32_ARRAY_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CUMULATIVE_PMCOMPLEX_RESET_COUNT, AttrMetadataStr(sizeof(ATTR_CUMULATIVE_PMCOMPLEX_RESET_COUNT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_PARAM_VALID, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_PARAM_VALID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_A_BUS_WIDTH, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_A_BUS_WIDTH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_MBA, AttrMetadataStr(sizeof(ATTR_CEN_MSS_RUNTIME_MEM_THROTTLE_NUMERATOR_PER_MBA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEC_IPL_TYPE, AttrMetadataStr(sizeof(ATTR_CEC_IPL_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MASTER_TYPE, AttrMetadataStr(sizeof(ATTR_PROC_MASTER_TYPE_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_DRAM_DRV_IMP_DQ_DQS, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_DRAM_DRV_IMP_DQ_DQS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN1, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_CNTL_D0_CSN1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VREF_CAL_CNTL, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VREF_CAL_CNTL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_ADC_CHANNEL_SENSOR_NUMBERS, AttrMetadataStr(sizeof(ATTR_ADC_CHANNEL_SENSOR_NUMBERS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PEC_PCIE_IOP_SWAP_BIFURCATED, AttrMetadataStr(sizeof(ATTR_PEC_PCIE_IOP_SWAP_BIFURCATED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_PROC_CHIPS_PER_NODE, AttrMetadataStr(sizeof(ATTR_MAX_PROC_CHIPS_PER_NODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_ISTEP_PAUSE_ENABLE, AttrMetadataStr(sizeof(ATTR_ISTEP_PAUSE_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_CTRL_OTHER_DBG0_STOP, AttrMetadataStr(sizeof(ATTR_HTMSC_CTRL_OTHER_DBG0_STOP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MEM_BASES, AttrMetadataStr(sizeof(ATTR_PROC_MEM_BASES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NX_RNG_BAR_ENABLE, AttrMetadataStr(sizeof(ATTR_PROC_NX_RNG_BAR_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CORE_THROTTLE_ASSERT_COUNT, AttrMetadataStr(sizeof(ATTR_CORE_THROTTLE_ASSERT_COUNT_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HYPERVISOR_IPL_DESTINATION, AttrMetadataStr(sizeof(ATTR_HYPERVISOR_IPL_DESTINATION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_BAR_SIZE, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_BAR_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_PHASE_COMB, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_PHASE_COMB_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_MEM_SCOPE, AttrMetadataStr(sizeof(ATTR_HTMSC_MEM_SCOPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_REDUNDANCY, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_REDUNDANCY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MB_BIT_RATE_DIVISOR_PLL, AttrMetadataStr(sizeof(ATTR_MB_BIT_RATE_DIVISOR_PLL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_SWD_SEQUENCE_ORDER, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_SWD_SEQUENCE_ORDER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_INIT_TO_AVAILABLE, AttrMetadataStr(sizeof(ATTR_INIT_TO_AVAILABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_STRUCT_ENDIAN, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_STRUCT_ENDIAN_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_APSS_CHIP_SELECT, AttrMetadataStr(sizeof(ATTR_PM_APSS_CHIP_SELECT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VDD_PROGRAM, AttrMetadataStr(sizeof(ATTR_MSS_VDD_PROGRAM_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_ENABLE_DL_TMPL_A, AttrMetadataStr(sizeof(ATTR_PROC_ENABLE_DL_TMPL_A_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SYSTEM_TYPE, AttrMetadataStr(sizeof(ATTR_SYSTEM_TYPE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PM_RESET_PHASE, AttrMetadataStr(sizeof(ATTR_PM_RESET_PHASE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_MODULE_HEIGHT, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_MODULE_HEIGHT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PHYS_PRES_REQUEST_OPEN_WINDOW, AttrMetadataStr(sizeof(ATTR_PHYS_PRES_REQUEST_OPEN_WINDOW_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_ZQCAL_INTERVAL, AttrMetadataStr(sizeof(ATTR_EFF_ZQCAL_INTERVAL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_ODT_INPUT_BUFF, AttrMetadataStr(sizeof(ATTR_EFF_ODT_INPUT_BUFF_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_P8EX_L3_LINE_DELETES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_P8EX_L3_LINE_DELETES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_CRC_ERROR_CLEAR, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_CRC_ERROR_CLEAR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VCS_AVSBUS_RAIL, AttrMetadataStr(sizeof(ATTR_VCS_AVSBUS_RAIL_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_VCS_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_VCS_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_BC0A, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_BC0A_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_XBUS_DCCAL_FLAGS, AttrMetadataStr(sizeof(ATTR_IO_XBUS_DCCAL_FLAGS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_ALLOWED_DIMM_FREQ, AttrMetadataStr(sizeof(ATTR_MAX_ALLOWED_DIMM_FREQ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_SCHMOO_TEST_VALID, AttrMetadataStr(sizeof(ATTR_CEN_EFF_SCHMOO_TEST_VALID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_INTER, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_INTER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IS_SP_MODE, AttrMetadataStr(sizeof(ATTR_IS_SP_MODE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_DSTLCFG_MMIO_ADDRBIT_POS, AttrMetadataStr(sizeof(ATTR_PROC_DSTLCFG_MMIO_ADDRBIT_POS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_ATTN_CHK_ALL_PROCS, AttrMetadataStr(sizeof(ATTR_ATTN_CHK_ALL_PROCS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_N_PLUS_ONE_N_PER_MBA, AttrMetadataStr(sizeof(ATTR_N_PLUS_ONE_N_PER_MBA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_CEN_L4_CACHE_CES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_CEN_L4_CACHE_CES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_PB_IOOFIR_MASK, AttrMetadataStr(sizeof(ATTR_IO_PB_IOOFIR_MASK_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_ZQCAL_INTERVAL, AttrMetadataStr(sizeof(ATTR_CEN_EFF_ZQCAL_INTERVAL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HDAT_HBRT_SECTION_SIZE, AttrMetadataStr(sizeof(ATTR_HDAT_HBRT_SECTION_SIZE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_RCD_PARITY_RECONFIG_LOOP_COUNT, AttrMetadataStr(sizeof(ATTR_RCD_PARITY_RECONFIG_LOOP_COUNT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_MCA_MHZ, AttrMetadataStr(sizeof(ATTR_FREQ_MCA_MHZ_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_RUN_DCD_CALIBRATION, AttrMetadataStr(sizeof(ATTR_MSS_RUN_DCD_CALIBRATION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_MEMORY_IUES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_MEMORY_IUES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_NHTM_CTRL_TRIG, AttrMetadataStr(sizeof(ATTR_NHTM_CTRL_TRIG_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PSI_BRIDGE_BASE_ADDR, AttrMetadataStr(sizeof(ATTR_PSI_BRIDGE_BASE_ADDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F0BCEx, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F0BCEx_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_1_VERSION_DATA, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_1_VERSION_DATA_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TARGET_HAS_POWER, AttrMetadataStr(sizeof(ATTR_TARGET_HAS_POWER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_REORDER_QUEUE_SETTING, AttrMetadataStr(sizeof(ATTR_MEM_REORDER_QUEUE_SETTING_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_RX_VGA_CNTL_REG1, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_RX_VGA_CNTL_REG1_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_IDLE_POWER_CONTROL_REQUESTED, AttrMetadataStr(sizeof(ATTR_MSS_MRW_IDLE_POWER_CONTROL_REQUESTED_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_POST_DRAM_INIT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_DDR3_VDDR_INTERCEPT_POST_DRAM_INIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DIMM_DDR4_F4BC3x, AttrMetadataStr(sizeof(ATTR_EFF_DIMM_DDR4_F4BC3x_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_REGISTER_TYPE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_REGISTER_TYPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_EXP_BOOT_CONFIG_DL_LAYER_BOOT_MODE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_EXP_BOOT_CONFIG_DL_LAYER_BOOT_MODE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MCS_GROUP_32, AttrMetadataStr(sizeof(ATTR_MSS_MCS_GROUP_32_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VCS_BOOT_VOLTAGE, AttrMetadataStr(sizeof(ATTR_VCS_BOOT_VOLTAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_FILT_MASK, AttrMetadataStr(sizeof(ATTR_HTMSC_FILT_MASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_TAAMIN, AttrMetadataStr(sizeof(ATTR_CEN_SPD_TAAMIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC0_SWB_VOLTAGE_OFFSET, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC0_SWB_VOLTAGE_OFFSET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DPO_MIN_FREQ_PERCENT, AttrMetadataStr(sizeof(ATTR_DPO_MIN_FREQ_PERCENT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_N_PLUS_ONE_HPC_BULK_POWER_LIMIT_WATTS, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_N_PLUS_ONE_HPC_BULK_POWER_LIMIT_WATTS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_EFF_FABRIC_GROUP_ID, AttrMetadataStr(sizeof(ATTR_PROC_EFF_FABRIC_GROUP_ID_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_SUPPORTED_FREQ, AttrMetadataStr(sizeof(ATTR_MSS_MRW_SUPPORTED_FREQ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HOT_PLUG_POWER_CONTROLLER_INFO, AttrMetadataStr(sizeof(ATTR_HOT_PLUG_POWER_CONTROLLER_INFO_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DRAM_AL, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DRAM_AL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_ICACHE_ASSOC_SETS, AttrMetadataStr(sizeof(ATTR_ICACHE_ASSOC_SETS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU0_MMIO_BAR_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_NPU0_MMIO_BAR_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MCBIST_ADDR_STR_MAP, AttrMetadataStr(sizeof(ATTR_CEN_MCBIST_ADDR_STR_MAP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_CWL, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_CWL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_MRW_NVDIMM_PLUG_RULES, AttrMetadataStr(sizeof(ATTR_MSS_MRW_NVDIMM_PLUG_RULES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_THERM_SENSOR_1_USAGE, AttrMetadataStr(sizeof(ATTR_MEM_EFF_THERM_SENSOR_1_USAGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_PMIC1_REVISION, AttrMetadataStr(sizeof(ATTR_MEM_EFF_PMIC1_REVISION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_DRAM_RTT_WR, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_DRAM_RTT_WR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_DRV_IMP_DQ_DQS_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_FAPI_NAME, AttrMetadataStr(sizeof(ATTR_FAPI_NAME_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_ADC_CHANNEL_FUNC_IDS, AttrMetadataStr(sizeof(ATTR_ADC_CHANNEL_FUNC_IDS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_BOOT_FREQ_MHZ, AttrMetadataStr(sizeof(ATTR_BOOT_FREQ_MHZ_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CVPD_SIZE, AttrMetadataStr(sizeof(ATTR_CVPD_SIZE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DIMM_DDR4_RC00, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DIMM_DDR4_RC00_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_WOF_VRATIO_SELECT, AttrMetadataStr(sizeof(ATTR_WOF_VRATIO_SELECT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_ECID, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_ECID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_EFF_VPD_VERSION, AttrMetadataStr(sizeof(ATTR_CEN_MSS_EFF_VPD_VERSION_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_MBAS_PER_MEMBUF_CHIP, AttrMetadataStr(sizeof(ATTR_MAX_MBAS_PER_MEMBUF_CHIP_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EXP_RESP_DDR4_F1RC00, AttrMetadataStr(sizeof(ATTR_MSS_EXP_RESP_DDR4_F1RC00_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PCI_BASE_ADDRS_32, AttrMetadataStr(sizeof(ATTR_PCI_BASE_ADDRS_32_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT32_2, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT32_2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_NIBBLE_ENABLES, AttrMetadataStr(sizeof(ATTR_MEM_EFF_NIBBLE_ENABLES_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_TLB_INSTR_ASSOC_SETS, AttrMetadataStr(sizeof(ATTR_TLB_INSTR_ASSOC_SETS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_VOLTAGE_EXT_VDD_BIAS_POWERSAVE, AttrMetadataStr(sizeof(ATTR_VOLTAGE_EXT_VDD_BIAS_POWERSAVE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_SPD_MODULE_PART_NUMBER, AttrMetadataStr(sizeof(ATTR_CEN_SPD_MODULE_PART_NUMBER_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_SCRATCH_UINT64_1, AttrMetadataStr(sizeof(ATTR_SCRATCH_UINT64_1_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PBAX_GROUPID, AttrMetadataStr(sizeof(ATTR_PBAX_GROUPID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_TH_P8EX_L2_CACHE_CES, AttrMetadataStr(sizeof(ATTR_MNFG_TH_P8EX_L2_CACHE_CES_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_PRIMARY_RANK_GROUP2, AttrMetadataStr(sizeof(ATTR_CEN_EFF_PRIMARY_RANK_GROUP2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_PM_MODE_FREQ_PERCENT, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_PM_MODE_FREQ_PERCENT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_OCMB_APPINTR_OBJ_HANDLE, AttrMetadataStr(sizeof(ATTR_MSS_OCMB_APPINTR_OBJ_HANDLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_DRAMINIT_RESET_DISABLE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_DRAMINIT_RESET_DISABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_SLOT_INDEX, AttrMetadataStr(sizeof(ATTR_SLOT_INDEX_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VDDR_OFFSET_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_OMI_MHZ, AttrMetadataStr(sizeof(ATTR_FREQ_OMI_MHZ_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_MODE_MARKERS_ONLY, AttrMetadataStr(sizeof(ATTR_HTMSC_MODE_MARKERS_ONLY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_TMPL_1_PACING, AttrMetadataStr(sizeof(ATTR_EXPLR_TMPL_1_PACING_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKN, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_D1_CLKN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_CACHE_ENABLE, AttrMetadataStr(sizeof(ATTR_CEN_MSS_CACHE_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_WR_PREAMBLE, AttrMetadataStr(sizeof(ATTR_EFF_WR_PREAMBLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MAX_VDD_CURRENT_READING, AttrMetadataStr(sizeof(ATTR_MAX_VDD_CURRENT_READING_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_SCHMOO_RD_EYE_MIN_MARGIN, AttrMetadataStr(sizeof(ATTR_EFF_SCHMOO_RD_EYE_MIN_MARGIN_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_MEM_SIZES_ACK, AttrMetadataStr(sizeof(ATTR_PROC_MEM_SIZES_ACK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FREQ_BIAS_NOMINAL, AttrMetadataStr(sizeof(ATTR_FREQ_BIAS_NOMINAL_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_FRU_ID, AttrMetadataStr(sizeof(ATTR_FRU_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_MODE_DIS_FORCE_GROUP_SCOPE, AttrMetadataStr(sizeof(ATTR_HTMSC_MODE_DIS_FORCE_GROUP_SCOPE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EXP_RCD_VOLTAGE_CTRL, AttrMetadataStr(sizeof(ATTR_MEM_EXP_RCD_VOLTAGE_CTRL_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_ENABLE_US_TMPL_A, AttrMetadataStr(sizeof(ATTR_EXPLR_ENABLE_US_TMPL_A_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRFI, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRFI_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRTP, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRTP_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_VREF_DQ_TRAIN_RANGE, AttrMetadataStr(sizeof(ATTR_EFF_VREF_DQ_TRAIN_RANGE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DATA_MASK, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DATA_MASK_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NV_OPS_TIMEOUT_MSEC, AttrMetadataStr(sizeof(ATTR_NV_OPS_TIMEOUT_MSEC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_OMI_DL_GROUP_POS, AttrMetadataStr(sizeof(ATTR_OMI_DL_GROUP_POS_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_OPEN_POWER_DIMM_ERROR_TEMP_DEG_C, AttrMetadataStr(sizeof(ATTR_OPEN_POWER_DIMM_ERROR_TEMP_DEG_C_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_VOLT_VDDR, AttrMetadataStr(sizeof(ATTR_MEM_EFF_VOLT_VDDR_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CS, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MT_DIMM_RCD_IBT_CS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_MMIO_BAR1_BASE_ADDR_OFFSET, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_MMIO_BAR1_BASE_ADDR_OFFSET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_WRITE_CRC, AttrMetadataStr(sizeof(ATTR_EFF_WRITE_CRC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_DMI_CEN_TX_FFE_POSTCURSOR, AttrMetadataStr(sizeof(ATTR_IO_DMI_CEN_TX_FFE_POSTCURSOR_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_DLL_PPD, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_DLL_PPD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PHYS_PATH, AttrMetadataStr(sizeof(ATTR_PHYS_PATH_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_EFF_DRAM_TRFC, AttrMetadataStr(sizeof(ATTR_MEM_EFF_DRAM_TRFC_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_X_MFG_CHK, AttrMetadataStr(sizeof(ATTR_IO_X_MFG_CHK_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_TEST_NEGATIVE_FCN, AttrMetadataStr(sizeof(ATTR_TEST_NEGATIVE_FCN_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_NPU1_PRI_CONFIG, AttrMetadataStr(sizeof(ATTR_PROC_NPU1_PRI_CONFIG_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MRW_FILTER_PLL_BUCKET, AttrMetadataStr(sizeof(ATTR_MRW_FILTER_PLL_BUCKET_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT, AttrMetadataStr(sizeof(ATTR_EXP_RUNTIME_MEM_THROTTLED_N_COMMANDS_PER_SLOT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_HTMSC_CRESPFILT_INVERT, AttrMetadataStr(sizeof(ATTR_HTMSC_CRESPFILT_INVERT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_X_LINK_DELAY, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_X_LINK_DELAY_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_CEN_DRV_IMP_SPCKE_SCHMOO, AttrMetadataStr(sizeof(ATTR_CEN_EFF_CEN_DRV_IMP_SPCKE_SCHMOO_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXP_MEM_THROTTLED_N_COMMANDS_PER_PORT, AttrMetadataStr(sizeof(ATTR_EXP_MEM_THROTTLED_N_COMMANDS_PER_PORT_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_VDM_SMALL_FREQ_DROP_N_S_OVERRIDE, AttrMetadataStr(sizeof(ATTR_VDM_SMALL_FREQ_DROP_N_S_OVERRIDE_type), false, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_ENABLE_DL_TMPL_4, AttrMetadataStr(sizeof(ATTR_PROC_ENABLE_DL_TMPL_4_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_VDDR_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_VDDR_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_FABRIC_X_ATTACHED_CHIP_ID, AttrMetadataStr(sizeof(ATTR_PROC_FABRIC_X_ATTACHED_CHIP_ID_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MEM_SI_SIGNATURE_HASH, AttrMetadataStr(sizeof(ATTR_MEM_SI_SIGNATURE_HASH_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_POST_DRAM_INIT, AttrMetadataStr(sizeof(ATTR_MSS_VOLT_DDR4_VDDR_SLOPE_POST_DRAM_INIT_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EXPLR_METADATA_ENABLE, AttrMetadataStr(sizeof(ATTR_EXPLR_METADATA_ENABLE_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_LRDIMM_WORD_X, AttrMetadataStr(sizeof(ATTR_EFF_LRDIMM_WORD_X_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_IO_OLLFIR_MASK, AttrMetadataStr(sizeof(ATTR_IO_OLLFIR_MASK_type), true, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C2, AttrMetadataStr(sizeof(ATTR_MSS_VPD_MR_MC_PHASE_ROT_ADDR_C2_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_PROC_PCIE_PCS_PCLCK_CNTL_PLLB, AttrMetadataStr(sizeof(ATTR_PROC_PCIE_PCS_PCLCK_CNTL_PLLB_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_RDVREF_CAL_ENABLE, AttrMetadataStr(sizeof(ATTR_MSS_RDVREF_CAL_ENABLE_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_TFAW, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_TFAW_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_DRAM_DLL_RESET, AttrMetadataStr(sizeof(ATTR_EFF_DRAM_DLL_RESET_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_DRTM_PAYLOAD_ADDR_MB_HB, AttrMetadataStr(sizeof(ATTR_DRTM_PAYLOAD_ADDR_MB_HB_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_MSS_VOLT_VCS_MILLIVOLTS, AttrMetadataStr(sizeof(ATTR_CEN_MSS_VOLT_VCS_MILLIVOLTS_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_NEST_VCS_ID, AttrMetadataStr(sizeof(ATTR_NEST_VCS_ID_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_EFF_NUM_RANKS_PER_DIMM, AttrMetadataStr(sizeof(ATTR_EFF_NUM_RANKS_PER_DIMM_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MSS_EFF_ODT_RD, AttrMetadataStr(sizeof(ATTR_MSS_EFF_ODT_RD_type), true, P0_PERSISTENCY, false) ),
        std::make_pair( ATTR_MNFG_ABUS_MIN_EYE_HEIGHT, AttrMetadataStr(sizeof(ATTR_MNFG_ABUS_MIN_EYE_HEIGHT_type), false, P3_PERSISTENCY, false) ),
        std::make_pair( ATTR_CEN_EFF_DRAM_TRP, AttrMetadataStr(sizeof(ATTR_CEN_EFF_DRAM_TRP_type), true, P0_PERSISTENCY, false) ),
    };
    iv_mapAttrMetadata.insert( l_pair,
        l_pair + (sizeof(l_pair)/sizeof(l_pair[0])) );

    #undef TARG_FN
}

}// namespace TARGETING

